import QtQuick 1.0
import "controls"

Rectangle {
    id: bookIntroductionPage
    anchors.fill: parent

    property bool datadone: true
    property bool resetBookInfoFlag: false
    Loadingwithclose{
        z:2
        bgwidth:parent.width
        bgheigh:parent.height
        visible: !datadone
        onClickclose: {
            datadone = true;
            bookNetMgr.CancelHttp();
        }
    }

    Popupwith1button{
        id:popup1
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        onClickbutton:{
            bookNetMgr.CancelHttp();
            visible = false;
        }
    }

    Popupwith1buttonCustomContent{
        id:popup2
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        onClickbutton:
        {
            visible = false;
        }
    }

    Popupwith2button{
        id: chargedefPopup
        z: 200
        visible: false
        bgwidth: parent.width
        bgheigh: parent.height
        leftButtonText:"确认"
        rightButtonText:"取消"
        onClickleft: {
           pressleftbutton=true;
           pressrightbutton=false;
           visible = false;
           datadone = false;
           if(purchaseMgrModel.chargedefDownload() ==0)
           {

               datadone = true;
           }
           else
           {
               datadone = false;
           }
        }
        onClickright:{
           pressleftbutton=true;
           pressrightbutton=false;
           visible = false;
        }
    }

    Popupwith2button{
        id: chargeInfoPopup
        z: 200
        visible: false
        bgwidth: parent.width
        bgheigh: parent.height
        leftButtonText:"确认"
        rightButtonText:"取消"
        onClickleft: {
           pressleftbutton=true;
           pressrightbutton=false;
           visible = false;
           purchaseMgrModel.payDownloadFee();
           datadone = false;
        }
        onClickright:{
           pressleftbutton=true;
           pressrightbutton=false;
           visible = false;
        }
    }

    Popupwith2button{
        id: chargeSuccessPopup
        z: 200
        visible: false
        bgwidth: parent.width
        bgheigh: parent.height
        content: "付款成功，已经添加到下载中心"
        leftButtonText:"查看"
        rightButtonText:"取消"
        onClickleft: {
            pressleftbutton=true;
            pressrightbutton=false;
            visible = false;
            ebookreadercontainer.lastpagenum = 6;
            ebookreadercontainer.changePage(8);
        }
        onClickright:{
            pressleftbutton=true;
            pressrightbutton=false;
            visible = false;
        }
    }

    AccTitleBar
    {
        id: accTitleBar
        anchors.top: parent.top
        anchors.left: parent.left
        titleBarWidth:parent.width
        titleBarHeight:50
        titleText: bookInfoModel.getTitleName()
        z: 1
        imgVisibleFlag: false

    }

    Rectangle {
        id: bookImage
        anchors.top: accTitleBar.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        height: 170+bookInfoContainer.colCount*30-60+title.paintedHeight
        color: "#DEDEDE"
        Image {
            id: bookDai
            anchors.top: parent.top
            anchors.topMargin: 15*bookInfoContainer.colCount+title.paintedHeight/2-25
            anchors.left: parent.left
            anchors.leftMargin: 45
            width: 82
            height: 118
            source: "pics/dai.png"
            smooth: true
        }
        Image{
            id:mirPicDai
            width:bookDai.width
            height: bookDai.height*1/3
            anchors.top: bookDai.bottom
            anchors.topMargin: 3
            anchors.left: book.left
            opacity: 0.6
            source: bookDai.source
            transform: Rotation {
                origin.x: mirPicDai.width / 2
                origin.y: mirPicDai.height /2
                axis.x: 1; axis.y: 0; axis.z: 0
                angle: 180
            }
        }
        Image {
            id: book
            anchors.top: parent.top
            anchors.topMargin: 15*bookInfoContainer.colCount+title.paintedHeight/2-25
            anchors.left: parent.left
            anchors.leftMargin: 45
            fillMode: Image.PreserveAspectFit
            source: bookInfoModel.bookImage
            smooth: true
        }
        Image{
            id:mirPic
            width:book.width
            height: book.height*1/3
            anchors.top: book.bottom
            anchors.topMargin: 3
            anchors.left: book.left
            opacity: 0.6
            source: book.source
            transform: Rotation {
                origin.x: mirPic.width / 2
                origin.y: mirPic.height /2
                axis.x: 1; axis.y: 0; axis.z: 0
                angle: 180
            }
        }

        Image {
            id: bookmask
            anchors.top: mirPicDai.top
            anchors.left: mirPicDai.left
            anchors.leftMargin: -2
            source: "pics/BookIntroduction_mask.png"
        }

        Text{
            id: title
            anchors.top: parent.top
            anchors.topMargin: 35
            anchors.left: parent.left
            anchors.leftMargin: 170
            width: 300
            font.pixelSize: 30
            wrapMode:Text.WordWrap
            text: "《" + bookInfoModel.bookName + "》"
        }

        Rectangle{
            id: bookInfoContainer
            anchors.left: title.left
            anchors.leftMargin: 5
            anchors.top: title.bottom
            anchors.topMargin: 15
            property int colCount: bookInfoModel.getColumnCount()
            Column{
                id: bookInfo
                spacing: 5

                Text{
                    visible:
                    {
                        if(bookInfoModel.auther == "")
                        {
                            return false;
                        }
                        else
                        {
                            return true;
                        }
                    }
                    font.pixelSize: 24
                    text: "作者： " + bookInfoModel.auther;
                }

                Text{
                    visible:
                    {
                        if(bookInfoModel.publisher == "")
                        {
                            return false;
                        }
                        else
                        {
                            return true;
                        }
                    }
                    font.pixelSize: 24
                    text: "提供商： " + bookInfoModel.publisher;
                }

                Text{
                    visible:
                    {
                        if(bookInfoModel.status == "")
                        {
                            return false;
                        }
                        else
                        {
                            return true;
                        }
                    }
                    font.pixelSize: 24
                    text: "章节数： " + bookInfoModel.status+"章";
                }

                Text{
                    visible:
                    {
                        if(bookInfoModel.price == "")
                        {
                            return false;
                        }
                        else
                        {
                            return true;
                        }
                    }
                    font.pixelSize: 24
                    text: "价格： " + bookInfoModel.price;
                }
            }
        }
    }

    Text{
        id: infoTitle
        anchors.left: parent.left
        anchors.leftMargin: 33
        anchors.top: bookImage.bottom
        anchors.topMargin: 15
        font.pixelSize: 32
        text:  "书籍简介"
    }

    Rectangle{
        id: info
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: infoTitle.bottom
        anchors.topMargin: 10
        height: 320 - bookInfoContainer.colCount*30 + 60 - title.paintedHeight +50

        Flickable {
            id: flick
            anchors.fill: parent
            anchors.leftMargin: 33
            anchors.rightMargin: 33
            contentWidth: parent.width - 66
            contentHeight: infoContent.paintedHeight
            flickableDirection: Flickable.VerticalFlick
            interactive: (parent.height >= contentHeight) ? false : true
            clip: true

            Text{
                id: infoContent
                anchors.fill: parent
                text: bookInfoModel.bookInfo
                width: parent.width
                color:"black";
                smooth:true;
                horizontalAlignment:Text.AlignLeft
                verticalAlignment :Text.AlignTop
                wrapMode:Text.WrapAtWordBoundaryOrAnywhere
                font.pixelSize: 26;
            }
        }
    }

    Rectangle{
        id: button
        anchors.right: parent.right
        anchors.rightMargin: 35
        anchors.bottom: toolbar.top
        anchors.bottomMargin: 10

        width: 190
        height: 55

        BorderImage {
            id: buttonImage
            source: "pics/download_Press.png"
            width: parent.width;
            height: parent.height
            smooth: true
        }

        BorderImage {
            id: pressed
            opacity: 0
            source: "pics/download.png"
            width: parent.width;
            height: parent.height
            smooth: true
        }

        MouseArea {
            id: mouseRegion
            anchors.fill: buttonImage
            onClicked: {
                checkOverDownload();
            }
        }

        Text {
            id: btnText
            color: "white"
            anchors.centerIn: buttonImage;
            text: "下载全书"
            font.pixelSize: 32
            font.bold: true
        }

        states: State {
            name: "Pressed"
            when: mouseRegion.pressed == true
            PropertyChanges { target: pressed; opacity: 1 }
        }
    }

    AccToolBar
    {
        id: toolbar
        anchors.left: parent.left
        anchors.bottom: parent.bottom
        z:1
        toolBarWidth:parent.width
        toolBarHeight:72
        bgImage:"../pics/toolbarbg.png"
        toolbarModel:toolbarModel
        hasBackButton: true
        onItemClicked:
        {
            switch(id)
            {
            case 0:
                {
                    ebookreadercontainer.lastpagenum = 6;
                    ebookreadercontainer.changePage(0);
                }
                break;
            case 1:
                {
                    ebookreadercontainer.lastpagenum = 6;
                    ebookreadercontainer.changePage(8);
                }
                break;
            case 2:
            {
                ebookreadercontainer.lastpagenum = 6;
                ebookreadercontainer.changePage(9);
            }
                break;
            default:
                break;
            }

        }
        onClickOnBack:
        {
            ebookreadercontainer.lastpagenum = 6;
            ebookreadercontainer.changePage(ebookreadercontainer.detailLastNum);
        }
    }

    ListModel{
        id: toolbarModel
        ListElement {
            itemHighlightImg: "../pics/MybookHighLight.png"
            itemImg: "../pics/Mybook.png"
        }
        ListElement {
            itemHighlightImg: "../pics/downloadIcon_focus.png"
            itemImg: "../pics/downloadIcon.png"
        }
        ListElement {
            itemHighlightImg: "../pics/AccountPress.png"
            itemImg: "../pics/Account.png"
        }
    }

    Popupwith2button{
        id: overloadPopup
        z: 1
        visible: false
        bgwidth: parent.width
        bgheigh:parent.height
        content: "本书已经存在，是否覆盖？"
        leftButtonText:"覆盖"
        rightButtonText:"取消"
        onClickleft: {
           pressleftbutton=true;
           pressrightbutton=false;
           visible = false;
           resetBookInfoFlag = true;
           checkBookDownload();
        }
        onClickright:{
           pressleftbutton=true;
           pressrightbutton=false;
           visible = false;
        }
    }

    function checkOverDownload()
    {
        switch(purchaseMgrModel.getDownloadedStatus(bookInfoModel.bookID,bookInfoModel.bookSize))
        {
        case 0:
            {
                checkBookDownload();
            }
            break;
        case 1:
            {
                if(ebooksetting.getIsNotifyUserOverwriteDL())
                {
                    overloadPopup.visible = true;
                }
                else
                {
                    resetBookInfoFlag = true;
                    checkBookDownload();
                }
            }
            break;
        case 2:
            {
                popup2.content = "该任务已经在下载中心，不能重复下载";
                popup2.visible = true;
            }
            break;
        case 4:
            {
                popup2.content = "手机空间不足，请手动释放空间。";
                popup2.visible = true;
            }
            break;

        default:
            {
                popup2.content = "未知错误";
                popup2.visible = true;
            }
            break;
        }
    }

    function checkBookDownload()//check if the book has been download
    {
        purchaseMgrModel.purchaseDownloadBook(bookInfoModel.bookID);
        datadone = false;
    }

    Component.onCompleted:
    {
        purchaseMgrModel.downloadResponse.connect(bookIntroductionPage.dataFinished);
    }

    function dataFinished(errorCode, status, text)
    {
        datadone = true;

        if(errorCode != 200)
        {
            popup1.errorCode = errorCode;
            popup1.visible = true;
            return;
        }

        switch(status)
        {
        case 0:
            {
                ebookreadercontainer.lastpagenum = 6;
                deleteBookFromDB();
                ebookreadercontainer.changePage(8);
            }
            break;
        case 1:
            {
                chargedefPopup.content = text;
                chargedefPopup.visible = true;
            }
            break;
        case 2:
            {
                chargeInfoPopup.content = text;
                chargeInfoPopup.visible = true;
            }
            break;
        case 3:
            {
                deleteBookFromDB();
                chargeSuccessPopup.visible = true;
            }
            break;
        case 5:
            {
                popup2.content = "付款失败";
                popup2.visible = true;
            }
            break;
        default:
            {
                popup1.errorCode = errorCode;
                popup1.visible = true;
            }
            break;
        }
    }

    function deleteBookFromDB()
    {
        if(resetBookInfoFlag)
        {
            if(!bookshelfMgrModel.DeleteEBookItem(bookInfoModel.bookID))
            {
            }
        }
        resetBookInfoFlag = false;
    }
}
