import QtQuick 1.0

Rectangle {
    id:bookpage
    property int angles
    property int pagewidth
    property int pageheight
    property int titleheight
    property bool hasbm: false
    signal previousPage
    signal nextPage
    width: pagewidth
    height: pageheight
    color: "transparent"
    Image {
        anchors.fill: parent
        source: "pics/BookPage.png"
    }
    ParallelAnimation {
        id:hide
        running: false
        NumberAnimation { target: bookpage; property: "angles"; to: -90; duration: 400 }
    }
    ParallelAnimation {
        id:show
        running: false
        NumberAnimation { target: bookpage; property: "angles"; to: 0; duration: 400 }
    }
    Component {
        id:bookline
        Rectangle {
            width: pagewidth-60
            height: 38
            color: "transparent"
            Text {
                anchors.left: parent.left
                anchors.verticalCenter: parent.verticalCenter
                width: {
                    if(parent.width < 60)return 0
                    else return parent.width
                }
                height: parent.height
                textFormat : Text.PlainText
                font.pixelSize : 27
                color: "black"
                wrapMode :Text.NoWrap
                text: content
            }
        }
    }
    ListModel{
        id:empty
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
        ListElement {
            content:""
        }
    }
    Rectangle {
        x:30
        y:bookmark.height
        width: pagewidth-60
        height: parent.height-60
        color: "transparent"
        ListView{
            id:linelist
            anchors.fill: parent
            height: parent.height
            width: parent.width
            model: empty
            delegate: bookline
            interactive: false
        }
    }
    Image {
        id: bookmark
        x:parent.width-3*width
        y:0
        height: 60
        source: "pics/PopupBookmark.png"
        visible: hasbm
    }
    Rectangle {
        id: jia
        y:0
        x:parent.width-width
        height: parent.height
        color: "transparent"
        width: {
            if(angles == 0)return 0
            else return parent.width/3-angles
        }
        Image{
            anchors.fill: parent
            smooth: true
            source: "pics/pages.png"
        }
    }
    onPreviousPage:{

        if(z == 2)
        {
            getBookContent();
            bookpage.hasbm = bookreader.IsBookMark();
            bookpage.visible = true;
            hide.stop();
            show.running = true;
            z = 1;
        }
        else if(z == 1)
        {
            z = 0;
        }
        else if(z == 0)
        {
            bookpage.visible = false;
            angles = -90;
            z = 2;
        }
    }
    onNextPage: {
        if(z == 2)
        {
            bookpage.visible = false;
            z = 0;
            angles = 0;
        }
        else if(z == 1)
        {
            show.stop();
            hide.running = true;
            z = 2;
        }
        else if(z == 0)
        {
            getBookContent();
            bookpage.hasbm = bookreader.IsBookMark();
            bookpage.visible = true;
            z = 1;
        }
    }
    transform: [
        Rotation { origin.x: 0; origin.y: 0; axis{ x: 0; y: 1; z: 0 } angle: angles}
    ]
    function getBookContent()
    {
        for(var num = 0;num<empty.count;num++)
        {
            empty.setProperty(num, "content", bookreader.GetOneLineContent(num));
        }
    }
    function firstEnter()
    {
        bookreader.GetFirstPageContent();
        getBookContent();
    }
}
