import QtQuick 1.0

Item {
    id: bookitem
    property int listwidth:480
    height: {
        if( hastitle == true)
            return listtitle.height+rec.height
        else return rec.height
    }
    width:listwidth
    Timer{
        id:clicktimer
        interval : 1000
        repeat : false
        running : false
        onTriggered: {
            morebutton.click = false;
            rec.click = false;
        }
    }
    Image {
        id:listtitle
        anchors.top: parent.top
        width: parent.width
        height: 60
        source: "pics/listtitle.png"
        visible: hastitle

        Text {
            x:20
            id:sorttitle
            anchors.verticalCenter: parent.verticalCenter
            text: titlename
            font.pixelSize: 25
        }
        Image{
            id:morebutton
            property bool click: false
            x:parent.width - 20 - width
            height: parent.height-20
            width: 160
            anchors.verticalCenter: parent.verticalCenter
            source: {
                if(morebutton.click==false)
                    return "pics/shopmore.png"
                else return "pics/shopmoreclicked.png"
            }
            Text {
                anchors.centerIn: parent
                text: "更多"
                font.pointSize: 15
                color: "white"
            }
            MouseArea{
                anchors.fill: parent
                onPressed: {
                    relist.closePanel();
                    morebutton.click = true;
                    clicktimer.running = true;
                }
                onReleased: {
                    if(morebutton.click == true)
                    {
                        relist.closePanel();
                        morebutton.click = false;
                        bookNetMgr.GetMoreRecommendInfo(bookmodelQt.getTitleID(index));
                        ebookreadercontainer.titlestringforMore = sorttitle.text;
                        ebookreadercontainer.changePage(7);
                    }
                }
                onExited: {
                    relist.closePanel();
                    morebutton.click = false;
                }
            }
        }
    }
    Rectangle {
        id:rec
        width: listwidth
        height: {
            if( type == 1)
                return 3*listtitle.height/2
            else return listtitle.height
        }
        property bool click: false
        anchors.top: {
            if( hastitle == true)
                return listtitle.bottom
            else return parent.top
        }
        anchors.left: parent.left
        Rectangle {
            id:currentitem
            anchors.fill: parent
            visible: {
                if(type == 1)
                    return true
                else return false
            }
            Rectangle {
                anchors.top: parent.top
                anchors.horizontalCenter: parent.horizontalCenter
                height: 1
                width: parent.width-16
                color: "#C6C6C6"
            }
            Image {
                id:bookpic
                x:20
                anchors.verticalCenter: parent.verticalCenter
                source: picpath
            }
            Text {
                x:30+bookpic.width
                y:parent.height/2-30
                text: "《"+name+"》"
                font.pointSize:15
            }
            Text {
                x:40+bookpic.width
                y:parent.height/2+10
                text: "作者： "+author
                font.pointSize:10
            }
            Image {
                x:parent.width-30-sourceSize.width
                anchors.verticalCenter: parent.verticalCenter
                source: "pics/shopindicate.png"
            }
        }

        Rectangle {
            id:notcurrentitem
            anchors.fill: parent
            visible: {
                if(type == 1)
                    return false
                else return true
            }
            Rectangle {
                anchors.top: parent.top
                anchors.horizontalCenter: parent.horizontalCenter
                height: 1
                width: parent.width-16
                color: "#C6C6C6"
            }
            Text {
                id:bookname
                x:20
                anchors.verticalCenter: parent.verticalCenter
                text: "《"+name+"》"
                font.pointSize:15
            }
            Text {
                x:40+bookname.width

                width: indi.x-x
                anchors.verticalCenter: parent.verticalCenter
                elide :Text.ElideRight
                text: content
                font.pointSize:10
            }
            Image {
                id:indi
                x:parent.width-30-sourceSize.width
                anchors.verticalCenter: parent.verticalCenter
                source: "pics/shopindicate.png"
            }
        }
        Image{
            anchors.fill: parent
            source: "pics/picbooklistclick.png"
            opacity: 0.4
            visible: {
                if(rec.click == true)return true
                else return false
            }
        }
        MouseArea{
            anchors.fill: parent
            onClicked: {
                relist.closePanel();
            }
            onPressed: {
                relist.closePanel();
                rec.click = true;
                clicktimer.running = true;
            }
            onReleased: {
                if(rec.click == true)
                {
                    relist.closePanel();
                    rec.click = false;
                    bookNetMgr.GetBookInfo(bookmodelQt.getBookID(index));
                    netshop.detailerror = true;
                    netshop.datadone = false;
                }
            }
            onExited: {
                relist.closePanel();
                rec.click = false;
            }
        }

    }
}

