import QtQuick 1.0
import "controls"

Rectangle {
    id: downloadcenterview
    anchors.fill: parent
    color: "white"
    property int clickItemState
    property string cidforpopup: ""
    property string booknameforpopup: "value"
    property string linkforpopup: "value"
    property int  lastpage: ebookreadercontainer.lastpagenum
    AccTitleBar{
        id:downloadcenterviewtitlebar
        x:0
        y:0
        titleBarWidth:parent.width
        titleBarHeight:50
        titleText: "下载中心"
        z:downloadlistview.z+51
        imgVisibleFlag: false
    }
    Image{
        id:showdownloadingtext
        x:0
        y:downloadcenterviewtitlebar.y+downloadcenterviewtitlebar.height
        width: parent.width
        height: 50
        source:"pics/titlebg.png"
        z:downloadcenterviewtitlebar.z
        Text {
            id: downloadingtext
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.verticalCenter: parent.verticalCenter
            font.pixelSize: 25
            text: "共"+downloadItemModel.downloadTotalNum+"本书，有"+downloadItemModel.downloadingNum+"本正在下载"
        }
    }

   ListModel{
            id: downloadingmenulist
            ListElement
            {
                menutext:"暂停下载"
            }
            ListElement
            {
                menutext:"删除下载"
            }

     }
   ListModel{
            id: downloadingmenulist1
            ListElement
            {
                menutext:"恢复下载"
            }
            ListElement
            {
                menutext:"删除下载"
            }

     }
    Popupwith2button{
        id: deletePopup
        visible: false
        bgwidth: parent.width
        bgheigh:parent.height
        content: "是否删除本条下载任务？"
        z:parent.z+151
        leftButtonText:"确定"
        rightButtonText:"取消"
        onClickleft: {
            downloadMgr.RemoveTask(downloadcenterview.cidforpopup,downloadcenterview.linkforpopup);
            visible = false;
            pressleftbutton=true;
            pressrightbutton=false;
        }
        onClickright:{
            visible = false;
            pressleftbutton=true;
            pressrightbutton=false;
        }
    }
    PopupMenuWithULine{
       id: downloadingPopupMenu;
       visible: false
       bgwidth: parent.width
       bgheigh:parent.height
       textItemModel: (downloadcenterview.clickItemState==2)? downloadingmenulist1:downloadingmenulist
       z:parent.z+150
       onClickedmenuitem: {
           visible = false;
           switch(clickindex)
           {
           case 0:
               {
                   if(downloadcenterview.clickItemState==2){
                       downloadMgr.ReStartTask(downloadcenterview.cidforpopup,downloadcenterview.linkforpopup);
                    }
                   else
                   {
                     downloadMgr.PauseTask(downloadcenterview.cidforpopup,downloadcenterview.linkforpopup);
                   }
               }
               break;
           case 1:
               deletePopup.visible=true;
               break;
           default:
               break;
           }
       }
       onClickclose: {
           visible = false;
       }
    }
    Component {
        id: sectionHeading
        Item {
            width: downloadContainer.width
            height: downloadContainer.height/7
            Item {
                id:roundborder
                anchors.fill: parent
                Timer{
                    id:clicktimer
                    interval : 1000
                    repeat : false
                    running : false
                    onTriggered: {
                        downloadlistview.pressedItemflag = false;
                        running=false;
                    }
                }
                Item {
                    id:imageBorder
                    anchors.left: parent.left; anchors.leftMargin: 10
                    anchors.verticalCenter: parent.verticalCenter
                    width: 50
                    height:parent.height-10
                    Image{
                        id:daiimage
                        anchors.verticalCenter: parent.verticalCenter
                        anchors.horizontalCenter: parent.horizontalCenter
                        source: "pics/dai.png"
                        visible:(bookIcon.progress==1)? false:true
                    }
                    Image{
                        id: bookIcon
                        anchors.horizontalCenter:parent.horizontalCenter
                        anchors.verticalCenter:parent.verticalCenter
                        source: imagepath
                    }
                }
                Item{
                    id:progressRectangle
                    anchors.left:imageBorder.right; anchors.leftMargin: 20
                    anchors.right: parent.right
                    height:parent.height

                    Text {
                        id:booknamestring
                        anchors.left: parent.left
                        anchors.top: parent.top; anchors.topMargin: 20
                        width: percentagestring.x-booknamestring.x
                        font.pixelSize: 25
                        text: "《"+ bookname + "》"
                        elide :Text.ElideRight
                    }
                    Text {
                        id:percentagestring
                        anchors.right: parent.right;   anchors.rightMargin: 10
                        anchors.top: booknamestring.top
                        font.pixelSize: 25
                        text: (booktotalsize==0)? "0%":Math.floor(downloadedsize*100/booktotalsize) + "%"
                        elide :Text.ElideRight
                    }
                    Image{
                        id:remainedImage
                        anchors.left: parent.left; anchors.leftMargin: 10
                        anchors.bottom: parent.bottom; anchors.bottomMargin: 20
                        width: parent.width - 20
                        source: "pics/Remainder.png"
                    }
                    Image{
                        id:progressedImage
                        anchors.left: remainedImage.left;
                        anchors.bottom: remainedImage.bottom;
                        width: (booktotalsize==0)? 0:remainedImage.width*(downloadedsize/booktotalsize)
                        source: (downloadState==1)? "pics/Progressing.png":"pics/Pausing.png";

                    }
                }
                Rectangle {
                    border.color: "#C6C6C6"
                    border.width: 1
                    anchors.bottom: parent.bottom
                    anchors.bottomMargin: 1
                    anchors.horizontalCenter: parent.horizontalCenter
                    height: 1
                    width: parent.width - 16
                }
            }
            MouseArea{
               anchors.fill: parent
               onPressed: {
                   downloadlistview.pressedItemflag = true;
                   downloadlistview.currentIndex=index;
                   clicktimer.running=true;
               }
               onReleased: {
                   if(downloadlistview.pressedItemflag== true)
                   {
                       downloadlistview.pressedItemflag = false;
                   }
               }
               onExited:  {
                   if(downloadlistview.pressedItemflag== true)
                   {
                       downloadlistview.pressedItemflag = false;
                   }
               }
               onPressAndHold:{
                   downloadcenterview.clickItemState= downloadItemModel.getStateByIndex(index);
                   downloadcenterview.cidforpopup =cid;
                   downloadcenterview.booknameforpopup=bookname;
                   downloadcenterview.linkforpopup=link;
                   if(downloadedsize<booktotalsize){
                       downloadingPopupMenu.visible=true;
                   }
               }

            }
        }
    }

    Rectangle {
        id:downloadContainer
        x:0
        y:showdownloadingtext.y+showdownloadingtext.height
        width: parent.width
        height: parent.height-downloadcenterviewtitlebar.height-showdownloadingtext.height-toolbar.height
        color: "transparent"
        property int downloadingIndex: 0
        ListView{
            id:downloadlistview
            property bool pressedItemflag
            anchors.fill: parent
            model: downloadItemModel
            interactive:(downloadItemModel.downloadTotalNum <=7)? false:true
            orientation: ListView.Vertical
            focus:true
            snapMode:ListView.SnapToItem
            delegate:sectionHeading
            keyNavigationWraps: true
            highlightFollowsCurrentItem:false
            highlight: Component {
                id: highlight
                    Image {
                        id:highlightRectamgle
                        visible: downloadlistview.pressedItemflag
                        height: downloadlistview.height/7
                        width: downloadContainer.width
                        anchors.centerIn: downloadlistview.currentItem
                        smooth: true
                        opacity: 0.8
                        source: "pics/IndexSelected.png"
                        z:downloadlistview.z+2
                    }
            }
            Component.onCompleted:{
                downloadlistview.pressedItemflag = false;
           }
        }
    }

    ListModel{
        id: toolbarModel

        ListElement {
            itemHighlightImg: "../pics/MybookHighLight.png"
            itemImg: "../pics/Mybook.png"
        }
    }
    AccToolBar{
        id:toolbar
        x:0
        y:parent.height-toolbar.height
        z:51
        toolBarWidth:parent.width
        toolBarHeight:72
        toolbarModel: toolbarModel
        bgImage:"../pics/toolbarbg.png"
        highlightBgImage:"../pics/highlight.png"
        hasBackButton: true
        onItemClicked:{
            switch(id)
            {
                case 0:
                {
                    ebookreadercontainer.changePage(0);
                    break;
                }
                default:
                    break;
            }
        }
        onClickOnBack: {
            if(ebookreadercontainer.lastpagenum == 6){
                ebookreadercontainer.changePage(6);
            }
            if(ebookreadercontainer.lastpagenum == 0){
                ebookreadercontainer.changePage(0);
            }
            if(ebookreadercontainer.lastpagenum == 3){
                ebookreadercontainer.changePage(3);
            }
            if(ebookreadercontainer.lastpagenum == 4){
                ebookreadercontainer.changePage(4);
            }
            if(ebookreadercontainer.lastpagenum == 5){
                ebookreadercontainer.changePage(5);
            }
        }
    }

    Component.onCompleted:{
        downloadMgr.downloadFinishedResponse.connect(downloadcenterview.checkdisablepopup);
        downloadMgr.downloadFinishedResponse.connect(downloadcenterview.updaPageIconstate);
        downloadMgr.AutomaticDownloadTask();
    }
    function checkdisablepopup(cid,bookStorePath){
        if(cid==downloadcenterview.cidforpopup&&downloadingPopupMenu.visible==true){
            downloadingPopupMenu.visible=false;
        }
        if(cid==downloadcenterview.cidforpopup&&deletePopup.visible==true){
            deletePopup.visible=false;
        }
    }
    function updaPageIconstate(cid,bookStorePath){
    }
}
