import QtQuick 1.0
import "controls"

Rectangle {
    anchors.fill: parent
    property string tabimagepath1: "pics/PageTitleLightGreen.png"
    property string tabimagepath2: "pics/PageTitleGrayDivide.png"
    property bool presstab1: true
    property bool presstab2: false
    property string helpcontent:"亲爱的书友，欢迎使用河马读书！"+"<br/>"+
    "河马读书是行学一族旗下的最新的一款读书软件，用户通过“河马读书”可以阅读网络书城中的海量内容，包括：数以万计的在线小说、图书、漫画、杂志。这些图书来自国内顶级的内容提供商：磨铁图书、起点文学、新浪文学等等。"+"<br/>"+
    "[下载新书]"+"<br/>"+
    "步骤一：客户端启动后，单击“网上书城”图标，即可发起联网操作，联网成功之后会进入“网上书城”界面；"+"<br/>"+
    "步骤二：您可以在书城界面单击任何图书，或者图书栏目，或者进行搜索，找到您喜欢的图书；"+"<br/>"+
    "步骤三：进入书籍简介页面后，您可以单击“下载全书”，然后下载任务会自动添加到“下载中心”，稍等片刻即可完成下载；"+"<br/>"+
    "步骤四：下载完成的书籍，会存在“我的书架”最上面，带有“新书”的标记；"+"<br/>"+
    "[搜书]"+"<br/>"+
    "进入“我的书架”或“网上书城”界面，单击下侧“搜索”图标，即可开始进行书籍搜索；"+"<br/>"+
    "[导入自有格式的书籍]"+"<br/>"+
    "客户端软件支持从河马读书网站（http://www.mobiledu.cn）下载NBP书籍，同时用户可以自行将NBP文件导入到客户端中。"+"<br/>"+
    "步骤一：用户通过“大容量存储模式”连接PC和手机；"+"<br/>"+
    "步骤二：将电脑上的 NBP文件拷贝到手机的HippoReader目录下（将nbp文件直接放在HippoReader目录下，不要再建子文件夹，且不要修改nbp文件的名称）；"+"<br/>"+
    "步骤三：重新启动“河马读书”，即可看到新导入的书籍；"+"<br/>"+
    "[阅读书籍]"+"<br/>"+
    "打开一本书籍后："+"<br/>"+
    "向前翻页：单击屏幕左侧或在屏幕上向左滑动，则向前翻页；"+"<br/>"+
    "向后翻页：单击屏幕右侧或在屏幕上向右滑动，则向后翻页；"+"<br/>"+
    "全屏阅读：点击屏幕中央，可以切换全屏或者非全屏模式；"+"<br/>"+
    "添加书签：在非全屏模式下，单击“书签”按钮，即可添加书签，再次单击“书签”按钮则去掉书签；"+"<br/>"+
    "查看目录：在非全屏模式下，单击“目录”按钮，即可查看当前书籍的章节目录；"+"<br/>"+
    "[联网]"+"<br/>"+
    "河马读书在浏览和下载书籍时，需向网络运营商支付流量费。"+"<br/>"+
    "我们强烈建议您使用GPRS包月套餐方式或者WLAN连接，套餐服务可大量节省您的流量费用。"+"<br/>"
    property string aboutcontent: "[免责声明]"+"<br/>"+
                                  "您将使用的第三方应用程序并非由诺基亚拥有或开发。诺基亚不承担应用程序任何方面的任何责任，包括但并不限于其性能、使用时产生的费用，知识产权或支持。欲了解详情，请参阅相应的附加应用指南。"+"<br/>"+
                                  "阅读本页中的内容，将承认您已理解以上条款和（相应的附加应用指南）中的条款，并且您已同意受其约束。"+"<br/>"+
                                  "本应用程序由诺培互联（北京）科技有限公司提供。"+"<br/>"+
                                  "客服电话：4006900000"+"<br/>"+
                                  "客服邮址：service@mobiledu.com.cn"+"<br/>"+
                                  "[关于]"+"<br/>"+
                                  "产品名称：河马读书"+"<br/>"+
                                  "版本号：2.0.27"+"<br/>"+
                                  "公司名称：诺培互联"+"<br/>"+
                                  "网站域名：wap.mobiledu.cn"+"<br/>"+
                                  "产品简介："+"<br/>"+
                                  "行学一族系列软件是由全球最大手机厂商诺基亚与全球最大教育与出版集团培生联手推出的，为手机端用户提供教育、阅读、娱乐的平台。"+"<br/>"+
                                  "河马读书是行学一族旗下的一款读书软件，用户通过“河马读书”可以阅读网络书城中的海量内容，包括：数以万计的在线小说、图书、漫画、杂志，这些图书来自国内顶级的内容提供商：磨铁图书、起点文学、新浪文学等等，“河马读书”意在为用户打造一款便捷、易用、轻量级的移动阅读软件，并为用户阅读创造一个理想的环境。"+"<br/>"

    AccTitleBar{
        id:oldtitlebar
        x:0
        y:0
        z:100
        titleBarWidth:parent.width
        titleBarHeight:50
        titleText: "帮助关于"
        imgVisibleFlag: false
    }
    AccToolBar{
        id:toolbar
        x:0
        y:parent.height-toolbar.height
        z:100
        toolBarWidth:parent.width
        toolBarHeight:72
        bgImage:"../pics/toolbarbg.png"
        highlightBgImage:"../pics/highlight.png"
        hasBackButton: true
        onClickOnBack: {
            ebookreadercontainer.changePage(ebookreadercontainer.lastpagenum);
        }
    }
    Image {
        id: tab1image
        x:0
        anchors.top: oldtitlebar.bottom
        width: parent.width/2
        height: 60
        source: (presstab1==true)? tabimagepath1:tabimagepath2
        Text{
            anchors.verticalCenter: tab1image.verticalCenter
            anchors.horizontalCenter : tab1image.horizontalCenter
            color: (presstab1==true)? "white":"black"
            font.pixelSize: 25
            text: "帮助"
        }
        MouseArea{
            anchors.fill: parent
            onPressed: {
                presstab1=true;
                presstab2=false;
            }
            onClicked:{
            }
        }
    }
    Image {
        id: tab2image
        x:parent.width/2
        anchors.top: oldtitlebar.bottom
        width: parent.width/2
        height: 60
        source: (presstab2==true)? tabimagepath1:tabimagepath2
        Text{
            anchors.verticalCenter: tab2image.verticalCenter
            anchors.horizontalCenter : tab2image.horizontalCenter
            color: (presstab2==true)? "white":"black"
            font.pixelSize: 25
            text: "关于"
        }

        MouseArea{
            anchors.fill: parent
            onPressed: {
                presstab2=true;
                presstab1=false;
            }
            onClicked:{

            }
        }
    }
    Rectangle{
        id: info
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: tab1image.bottom
        anchors.topMargin: 10
        height: parent.height-70-oldtitlebar.height-toolbar.height

        Flickable {
            id: flickhelp
            anchors.fill: parent
            anchors.leftMargin: 33
            anchors.rightMargin: 33
            contentWidth: parent.width - 66
            contentHeight: helpContent.paintedHeight
            visible: presstab1
            flickableDirection: Flickable.VerticalFlick
            interactive: (parent.height >= contentHeight) ? false : true
            clip: true

            Text{
                id: helpContent
                anchors.fill: parent
                text: helpcontent
                width: parent.width
                color:"black";
                smooth:true;
                textFormat : Text.RichText
                horizontalAlignment:Text.AlignLeft
                verticalAlignment :Text.AlignTop
                wrapMode:Text.WrapAtWordBoundaryOrAnywhere
                font.pixelSize: 25;
            }
        }
        Flickable {
            id: flickabout
            anchors.fill: parent
            anchors.leftMargin: 33
            anchors.rightMargin: 33
            contentWidth: parent.width - 66
            contentHeight: aboutContent.paintedHeight
            visible: presstab2
            flickableDirection: Flickable.VerticalFlick
            interactive: (parent.height >= contentHeight) ? false : true
            clip: true

            Text{
                id: aboutContent
                anchors.fill: parent
                text: aboutcontent
                width: parent.width
                color:"black";
                smooth:true;
                textFormat : Text.RichText
                horizontalAlignment:Text.AlignLeft
                verticalAlignment :Text.AlignTop
                wrapMode:Text.WrapAtWordBoundaryOrAnywhere
                font.pixelSize: 25;
            }
        }
    }
}
