import Qt 4.7
import "controls"

Rectangle {
    id:container
    property int bgwidth: parent.width
    property int bgheigh: parent.height
    property variant functioncontain    //EBookReaderContainer
    property string tabimagepath1: "pics/PageTitleLightGreen.png"
    property string tabimagepath2: "pics/PageTitleGrayDivide.png"
    property string markIconPath: "pics/PopupBookmark.png"
    property int tabindex: 0
    property bool presstab1: true
    property bool presstab2: false
    property int backupcurrent:0
    property int hightlightItemBackup: 0
    property int pagenumber: 0
    property bool highlightflag: true
    property int indexbackupindex
    anchors.fill: parent
    color: "white"
    signal clickedmenuitem(string tabtype,int index)

    AccTitleBar{
        id:indexandmarktitlebar
        x:0
        y:0
        titleBarWidth:parent.width
        titleBarHeight:50
        titleText: " "+listItemModel.getBookName()
        z:menuitemtext.z+51
        imgVisibleFlag: false
    }

    Image {
        id: tab1image
        x:0
        y:indexandmarktitlebar.height-1
        width: container.bgwidth/2
        height: 60
        z:menuitemtext.z+50
        source: (presstab1==true)? tabimagepath1:tabimagepath2
        Text{
            anchors.verticalCenter: tab1image.verticalCenter
            anchors.horizontalCenter : tab1image.horizontalCenter
            color: (presstab1==true)? "white":"black"
            font.pixelSize: 25
            text: "目录"
        }
        MouseArea{
            anchors.fill: parent
            onClicked:{
                presstab1=true;
                presstab2=false;
               if(container.tabindex!=0){
                   container.tabindex=0;
                   bookreader.GetChapterList();
                   menuitemtext.currentIndex=container.indexbackupindex;
                   container.highlightflag=true;
                   menuitemtext.positionViewAtIndex(menuitemtext.currentIndex, ListView.Beginning);
                   if(listItemModel.listcount<11){
                   }else if(menuitemtext.atYBeginning){

                   }
                   else if(menuitemtext.atYEnd)
                   {

                   }
                   else
                   {
                   }
               }
            }
        }
    }
    Image {
        id: tab2image
        x:container.bgwidth/2-3
        y:indexandmarktitlebar.height-1
        width: container.bgwidth/2+3
        height: 60
        z:menuitemtext.z+50
        source: (presstab2==true)? tabimagepath1:tabimagepath2
        Text{
            anchors.verticalCenter: tab2image.verticalCenter
            anchors.horizontalCenter : tab2image.horizontalCenter
            color: (presstab2==true)? "white":"black"
            font.pixelSize: 25
            text: "书签列表"
        }

        MouseArea{
            anchors.fill: parent
            onClicked:{
                presstab2=true;
                presstab1=false;
               if(container.tabindex!=1){
                   container.tabindex=1;
                   container.indexbackupindex=menuitemtext.currentIndex;
                   menuitemtext.currentIndex=0;
                   bookreader.GetBookmarkList();
                   if(listItemModel.listcount<11){
                   }else if(menuitemtext.atYBeginning){
                   }
                   else if(menuitemtext.atYEnd)
                   {

                   }else
                   {
                   }
                   container.highlightflag=false;
               }
            }
        }
    }
    ListModel
    {
           id: bookmarkmenulist
           ListElement
           {
               menutext:"打开书签"
           }
           ListElement
           {
               menutext:"删除书签"
           }

    }

    Popupwith2button{
        id: deletePopup
        visible: false
        bgwidth: parent.width
        bgheigh:parent.height
        content: "是否立即删除？"
        z:parent.z+151
        leftButtonText:"确定"
        rightButtonText:"取消"
        onClickleft: {
           bookreader.DeleteOneBookMark(menuitemtext.currentIndex);
           pressleftbutton=true;
           pressrightbutton=false;
           visible = false;
        }
        onClickright:{
           pressleftbutton=true;
           pressrightbutton=false;
           visible = false;
        }
    }

    PopupMenuWithULine{
       id: bookPopupMenu;
       visible: false
       bgwidth: parent.width
       bgheigh:parent.height
       textItemModel: bookmarkmenulist
       z:parent.z+150
       onClickedmenuitem: {
           visible = false;
           switch(clickindex)
           {
           case 0:
               {
               bookPopupMenu.visible=false;
               ebookreadercontainer.lastpagenum=2;
               bookreader.GetInfomationFromBookMark(menuitemtext.currentIndex);
               ebookreadercontainer.changePage(1);
               }
               break;
           case 1:
               {
                   bookPopupMenu.visible=false;
                   deletePopup.visible=true;
               }
               break;
           default:
               break;
           }
       }
       onClickclose: {
           visible = false;
       }
    }
    Component {
        id: sectionHeading
        Item {
            width: container.width; height: menuitemtext.height/11
            Rectangle {
                id:roundborder
                width: container.width
                height: parent.height
                Image{
                    id: markIcon
                    x:4+5
                    anchors.verticalCenter: roundborder.verticalCenter
                    width:20
                    visible: container.tabindex==0? false:true
                    source: markIconPath
                }
                Text {
                    id:datestring
                    x:35+5
                    anchors.verticalCenter: roundborder.verticalCenter
                    font.pixelSize: 25
                    text: container.tabindex==0? "":listItemModel.retDate(menutext)
                    color: "#6db339"
                    visible: container.tabindex==0? false:true
                }
                Text {
                    id:textstring
                    x:container.tabindex==0? 11:35+datestring.paintedWidth+5
                    width: container.tabindex==0? (parent.width-11):(parent.width-35-datestring.paintedWidth-20-5)
                    anchors.verticalCenter: roundborder.verticalCenter
                    font.pixelSize: 25
                    text: container.tabindex==0? menutext : listItemModel.retCon(menutext)
                    wrapMode:container.tabindex==0?Text.WordWrap:Text.NoWrap
                    elide :container.tabindex==0?Text.ElideNone:Text.ElideRight
                }
                Rectangle {
                    anchors.bottom: parent.bottom
                    anchors.bottomMargin: 1
                    anchors.horizontalCenter: parent.horizontalCenter
                    height: 1
                    width: parent.width-16
                    color: "#C6C6C6"
                }
            }

            MouseArea{
               anchors.fill: parent
               onPressed: {
                   if(container.tabindex==0)
                   {
                       hightlightItemBackup=menuitemtext.currentIndex;
                       menuitemtext.currentIndex=index;
                       if(listItemModel.listcount<11){

                       }else if(menuitemtext.atYBeginning){

                       }
                       else if(menuitemtext.atYEnd)
                       {

                       }else
                       {

                       }
                   }
                   else
                   {
                       if(container.highlightflag==false){
                         container.highlightflag=true;
                       }
                       menuitemtext.currentIndex=index;
                   }
               }

               onPressAndHold:{
                   if(container.tabindex==1){
                       bookPopupMenu.visible=true;
                   }
               }

               onClicked: {
                    menuitemtext.currentIndex=index;
                    if(tabindex==0){
                        container.checkIfCanGotoIndex(bookreader.GetInfomationFromChapter("chapterlist",index));
                    }
                    else
                    {
                        if(listItemModel.listcount>0){
                            if(index<(listItemModel.listcount)){
                            bookreader.GetInfomationFromBookMark(index);
                            }
                        }
                    }
                    if((tabindex==1)&&listItemModel.listcount>0){
                        ebookreadercontainer.lastpagenum=2;
                        ebookreadercontainer.changePage(1);
                    }
                }
            }
        }
    }

    Rectangle{
        id:listRound
        x:0
        y:tab2image.y+tab2image.height+1
        width: container.bgwidth
        height: container.bgheigh-indexandmarktitlebar.height-tab2image.height-toolbar.height
        color: "transparent"
        anchors{ top:tab1image.BottomLeft;}
        ListView{
                id: menuitemtext
                x:listRound.x
                y:listRound.y
                z:listRound.z+1
                height: listRound.height
                anchors.fill: parent
                interactive:(listItemModel.listcount <=11)? false:true
                model: listItemModel
                orientation: ListView.Vertical
                focus:true
                snapMode:ListView.SnapToItem
                delegate:sectionHeading
                keyNavigationWraps: true
                highlightFollowsCurrentItem:false
                highlight: Component {
                    id: highlight
                    Rectangle{
                        id:highlightRectamgle
                        height: menuitemtext.height/11
                        width: container.width
                        z:menuitemtext.z+1
                        visible: container.highlightflag
                        color: "transparent"
                        opacity: 0.8
                        anchors.centerIn: menuitemtext.currentItem
                        Image {
                            height: menuitemtext.height/11
                            width: container.width
                            smooth: true
                            source: "pics/IndexSelected.png"
                            z:parent.z+2
                        }
                    }
              }

            Component.onCompleted: {
                menuitemtext.currentIndex=listItemModel.getCurrentIndex();
                if(listItemModel.listcount<11){

                }else if(menuitemtext.atYBeginning){

                }
                else if(menuitemtext.atYEnd)
                {

                }
                else
                {

                }
                menuitemtext.positionViewAtIndex(menuitemtext.currentIndex, ListView.Beginning);
            }
        }
    }

    ListModel{
        id: toolbarModel
        ListElement {
            itemHighlightImg: "../pics/MybookHighLight.png"
            itemImg: "../pics/Mybook.png"
        }
    }
    AccToolBar{
        id:toolbar
        x:0
        y:parent.height-toolbar.height
        z:menuitemtext.z+51
        toolBarWidth:parent.width
        toolBarHeight:72
        toolbarModel: toolbarModel
        bgImage:"../pics/toolbarbg.png"
        highlightBgImage:"../pics/highlight.png"
        hasBackButton: true
        onItemClicked:{
            switch(id)
            {
                case 0:
                {
                    bookreader.SetPreChapterNum();
                    ebookreadercontainer.lastpagenum=2;
                    ebookreadercontainer.changePage(0);
                    break;
                }
                default:
                    break;
            }
        }
        onClickOnBack: {
            bookreader.SetPreChapterNum();
            ebookreadercontainer.lastpagenum=2;
            ebookreadercontainer.changePage(1);
        }
    }

    Loadingwithclose{
        id:loadingpage
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        visible: false

        onClickclose: {
            bookreader.SetPreChapterNum();
            bookNetMgr.CancelHttp();
            visible = false;
        }
    }
    Popupwith1button{
        id:popup1
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        onClickbutton:{
            bookreader.SetPreChapterNum();
            visible = false;
        }
    }
    Popupwith2button{
        id: purchasePopup
        visible: false
        bgwidth: parent.width
        bgheigh:parent.height
        z:200
        leftButtonText:"确定"
        rightButtonText:"取消"
        onClickleft: {
            loadingpage.visible = true;
            visible = false;
            if(bookreader.DoneBaseOnSingals() == 1)
            {

                loadingpage.visible = true;
            }
            else
            {
                loadingpage.visible = false;
            }

            pressleftbutton=true;
            pressrightbutton=false;
            visible = false;
        }
        onClickright:{
            bookreader.SetPreChapterNum();
            pressleftbutton=true;
            pressrightbutton=false;
           visible = false;
        }
    }
    Popupwith1buttonCustomContent{
        id:retPopup
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        onClickbutton:
        {
            ebookreadercontainer.lastpagenum=2;
            ebookreadercontainer.changePage(1);
            visible = false;
        }
    }
    Popupwith1buttonCustomContent{
        id:retPopupFail
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        onClickbutton:
        {
            visible = false;
        }
    }
    Component.onCompleted: {
        bookreader.emitDrmInfo.connect(container.payPopup);
    }

    function payPopup(errorcode,status,textContent)
    {
        loadingpage.visible = false;
        purchasePopup.visible = false;
        retPopup.visible = false;
        if(errorcode == 200)
        {
            switch(status)
            {
            case 0:
                {
                if(isNextPage == true)
                    nextPage();
                else prePage();
                    break;
                }
            case 1:
                {
                    purchasePopup.content = textContent;
                    purchasePopup.visible = true;
                    break;
                }
            case 2:
                {
                    purchasePopup.content = textContent;
                    purchasePopup.visible = true;
                    break;
                }
            case 3:
                {
                    retPopup.content = "付费成功!"
                    retPopup.visible = true;
                    break;
                }
            case 5:
                {
                    bookreader.SetPreChapterNum();
                    retPopupFail.content = "付费失败!"
                    retPopupFail.visible = true;
                    break;
                }
            default:
                {
                    bookreader.SetPreChapterNum();
                    retPopup.content = "未知错误";
                    retPopup.visible = true;
                    break;
                }
            }
        }
        else {
            popup1.errorCode = errorcode;
            popup1.visible = true;
        }

    }
    function checkIfCanGotoIndex(error)
    {
        switch(error)
        {
        case 0:
            {
            ebookreadercontainer.lastpagenum=2;
            ebookreadercontainer.changePage(1);
            break;
            }
        case 1:
            {
            retPopup.content = "文件出错了"
            retPopup.visible = true;
            break;
            }
        case 2:
            {
            retPopup.content = "文件出错了"
            retPopup.visible = true;
            break;
            }
        case 3:
            {
            retPopup.content = "文件出错了"
            retPopup.visible = true;
            break;
            }
        case 4:
            {
            retPopup.content = "文件出错了"
            retPopup.visible = true;
            break;
            }
        case 5:
            {
            retPopup.content = "文件出错了"
            retPopup.visible = true;
            break;
            }
        case 6:
            {
            retPopup.content = "文件出错了"
            retPopup.visible = true;
            break;
            }
        case 7:
            {
            loadingpage.visible = true
            break;
            }
        case 8:
            {
            retPopup.content = "文件出错了"
            retPopup.visible = true;
            break;
            }

        default:
            {
                break;
            }
        }
    }
}
