import QtQuick 1.0
import "controls"

Rectangle {
        id: morerecommandview   
        //Var
        property int bgwidth: parent.width
        property int bgheigh: parent.height
        property bool isGetScroll: false
        anchors.fill: parent
        color: "white"
        AccTitleBar{
            id:morerecommandviewtitlebar
            x:0
            y:0
            titleBarWidth:parent.width
            titleBarHeight:50
            titleText: ebookreadercontainer.titlestringforMore
            z:moreRecommandListView.z+51
            imgVisibleFlag: false
        }
        Component{
           id:sectionHeading
           Item {
               id:listitem
               width: morerecommandview.width
               height: moreRecommandListView.height/7
               property bool pressedItemflag: false

               Timer{
                   id:clicktimer
                   interval : 1000
                   repeat : false
                   running : false
                   onTriggered: {
                       listitem.pressedItemflag = false;
                   }
               }
               Rectangle{
                      id:highlightRectamgle
                      height: parent.height
                      width: morerecommandview.width
                      z:moreRecommandListView.z+1
                      color: "transparent"
                      opacity: 0.8
                      visible:listitem.pressedItemflag
                      Image {
                          height: parent.height
                          width: morerecommandview.width
                          smooth: true
                          source: "pics/IndexSelected.png"
                          z:parent.z+2
                      }
                  }
               Rectangle {
                   id:roundborder
                   width: morerecommandview.width
                   height: parent.height
                   color: "white"
                   Rectangle{
                       id:imagborder
                       x:roundborder.x+20
                       width: 53
                       height: 75
                       anchors.verticalCenter: roundborder.verticalCenter
                       Image{
                           id:daiimage
                           anchors.verticalCenter: parent.verticalCenter
                           anchors.horizontalCenter: parent.horizontalCenter
                           source: "pics/dai.png"
                           visible:(bookimage.progress==1)? false:true
                       }
                       Image{
                           id: bookimage
                           anchors.verticalCenter: parent.verticalCenter
                           width: 53
                           height: 75
                           source: imagepath
                           z:daiimage.z+1
                       }
                   }
                   Rectangle{
                       id:textroudborder
                       x:imagborder.x+imagborder.width+20
                       width: parent.width-20-imagborder.width-40
                       height: parent.height-18
                       y:parent.y+2
                           Text {
                               id:booknamestring
                               width: parent.width
                               y:parent.y
                               font.pixelSize: 20
                               text: "《"+bookname+"》"
                               elide :Text.ElideRight
                           }
                           Text {
                               id:authornamestring
                               x:booknamestring.x+10
                               width: parent.width
                               y:booknamestring.y+booknamestring.height
                               font.pixelSize: 15
                               text: "作者："+authorname
                               elide :Text.ElideRight
                           }
                           Text {
                               id:summarystring
                               x:booknamestring.x+10
                               width: parent.width
                               y:authornamestring.y+authornamestring.height
                               font.pixelSize: 15
                               text: summary
                               elide :Text.ElideRight
                           }
                           anchors.verticalCenter: roundborder.verticalCenter
                   }
                   Image {
                       id: bookItemBg
                       x: roundborder.width-40
                       anchors.verticalCenter: roundborder.verticalCenter
                       source: "pics/onlineSearch_indicator.png"
                   }
                      Rectangle {
                       anchors.bottom: parent.bottom
                       anchors.bottomMargin: 1
                       anchors.horizontalCenter: parent.horizontalCenter
                       height: 1
                       width: parent.width-16
                       color: "#C6C6C6"
                   }
               }
               MouseArea{
                    anchors.fill: parent
                    onPressed: {
                        listitem.pressedItemflag = true;
                        clicktimer.running = true;
                    }
                    onReleased: {
                        if(listitem.pressedItemflag== true)
                        {
                            listitem.pressedItemflag = false;
                        }
                    }
                    onClicked: {
                        bookNetMgr.GetBookInfo(bookID);
                        listRound.willgotobookinfo=true;
                        loadingpopup.visible= true;

                    }
               }
           }
       }

       Rectangle{
           id:listRound
           x:0
           y:morerecommandviewtitlebar.y+morerecommandviewtitlebar.height
           width: morerecommandview.bgwidth
           height: morerecommandview.bgheigh-morerecommandviewtitlebar.height-toolbar.height
           color: "transparent"
           property bool willgotobookinfo: false
           anchors{ top:morerecommandviewtitlebar.BottomLeft;}
           ListView{
                   id: moreRecommandListView
                   x:listRound.x
                   y:listRound.y
                   z:listRound.z+1
                   height: listRound.height/7
                   anchors.fill: parent
                   interactive:true
                   model: recommenddetailmodel
                   delegate:sectionHeading
                   focus:true
                   orientation: ListView.Vertical
                   currentIndex:0
                   snapMode:ListView.SnapToItem
                   highlightFollowsCurrentItem:false

                   onMovementEnded:
                   {
                       if(moreRecommandListView.model.count != 0)
                       {
                           if (moreRecommandListView.atYBeginning)
                           {

                           }
                           else if(moreRecommandListView.atYEnd)
                           {
                               if(!recommenddetailmodel.getIsMeetBottom())
                               {
                                   listRound.gonextpage();
                                   morerecommandview.isGetScroll = true;
                               }
                           }
                       }
                   }
           }
           function gotoprepage()
           {
               loadingpopup.visible=true;
               recommenddetailmodel.clickPageIcon(0);
          }
           function gonextpage()
           {
               loadingpopup.visible=true;
               recommenddetailmodel.clickPageIcon(1);
           }
       }

       Loadingwithclose{
           id:loadingpopup
           z:200
           bgwidth:parent.width
           bgheigh:parent.height
           visible:(ebookreadercontainer.lastpagenum==6)? false:true
           onClickclose: {
            bookNetMgr.CancelHttp();
               if(listRound.willgotobookinfo==false){
                   visible = false;
                   if(!morerecommandview.isGetScroll){
                    ebookreadercontainer.lastpagenum=7;
                    ebookreadercontainer.changePage(5);
                    recommenddetailmodel.clearAll();
                   }
               }else
               {
                  listRound.willgotobookinfo=false;
                   visible=false;
               }
           }
       }
       ListModel{
            id: toolbarModel
            ListElement {
                itemHighlightImg: "../pics/MybookHighLight.png"
                itemImg: "../pics/Mybook.png"
            }
        }
        AccToolBar{
            id:toolbar
            x:0
            y:parent.height-toolbar.height
            z:51
            toolBarWidth:parent.width
            toolBarHeight:72
            toolbarModel: toolbarModel
            bgImage:"../pics/toolbarbg.png"
            highlightBgImage:"../pics/highlight.png"
            hasBackButton: true
            onItemClicked:{
                switch(id)
                {
                    case 0:
                    {
                        ebookreadercontainer.lastpagenum=7;
                        ebookreadercontainer.changePage(0);
                        recommenddetailmodel.clearAll();
                        break;
                    }
                    default:
                        break;
                }
            }
            onClickOnBack: {
                ebookreadercontainer.lastpagenum=7;
                ebookreadercontainer.changePage(5);
                recommenddetailmodel.clearAll();
            }
        }
     Component.onCompleted:{
         bookNetMgr.moreRequestResponse.connect(morerecommandview.loadingDateFinish);
         bookNetMgr.bookInfoRequestResponse.connect(morerecommandview.finishedloadbookinfo);
     }

     function loadingDateFinish(errorCode){
        loadingpopup.visible= false;
        if(errorCode!=200){
             popup1.errorCode = errorCode;
             popup1.visible = true;
             return;
         }
     }

     function finishedloadbookinfo(errorCode){
        loadingpopup.visible= false;
        if(errorCode!=200){
             popup1.errorCode = errorCode;
             popup1.visible = true;
         }
        ebookreadercontainer.lastpagenum=7;
        ebookreadercontainer.changePage(6);
    }
     Popupwith1button{
         id:popup1
         z:200
         bgwidth:parent.width
         bgheigh:parent.height
         buttonText: "确认"
         visible:false
         onClickbutton:{
             ebookreadercontainer.lastpagenum=7;
             ebookreadercontainer.changePage(5);
             recommenddetailmodel.clearAll();
         }
     }

}
