import QtQuick 1.0
import "controls"

Rectangle {
    anchors.fill: parent
    property bool datadone: false
    Loadingwithclose{
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        visible: !datadone
        onClickclose: {
            bookNetMgr.CancelHttp();
            ebookreadercontainer.changePage(ebookreadercontainer.lastpagenum);
        }
    }
    Popupwith1button{
        id:popup1
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        onClickbutton:{
            ebookreadercontainer.changePage(ebookreadercontainer.lastpagenum);
        }
    }
    AccTitleBar{
        id:titlebar
        x:0
        y:0
        z:100
        titleBarWidth:parent.width
        titleBarHeight:50
        titleText: "我的帐户"
        imgVisibleFlag: false
    }
    ListModel{
        id: toolbarModel
        ListElement {
            itemHighlightImg: "../pics/MybookHighLight.png"
            itemImg: "../pics/Mybook.png"
            buttonText:"我的书架"
        }
    }
    Rectangle {
        anchors.top: titlebar.bottom
        anchors.bottom: itemList.top
        anchors.left: parent.left
        width: parent.width
        z:1
    }
    AccToolBar{
        id:toolbar
        x:0
        y:parent.height-toolbar.height
        z:100
        toolBarWidth:parent.width
        toolBarHeight:72
        bgImage:"../pics/toolbarbg.png"
        toolbarModel:toolbarModel
        highlightBgImage:"../pics/highlight.png"
        hasBackButton: true
        onItemClicked:{
            switch(id)
            {
                case 0:
                {
                    ebookreadercontainer.changePage(0);
                }
                    break;
                default:
                    break;
            }
        }
        onClickOnBack: {
            ebookreadercontainer.changePage(ebookreadercontainer.lastpagenum);
        }
    }

    Component {
        id:accountItem
        Item {
            width: parent.width
            height: {
                return itemOne.height>itemTwo.height? itemOne.height+20:itemTwo.height+20
            }
            Text {
                id:itemOne
                x:40
                width: 140
                wrapMode: Text.WrapAtWordBoundaryOrAnywhere
                anchors.verticalCenter: parent.verticalCenter
                text: itemText
                font.pixelSize: 25
                color: "black"
            }
            Text {
                id:itemTwo
                x:190
                y:itemOne.y
                width: parent.width/2
                wrapMode: Text.WrapAtWordBoundaryOrAnywhere
                anchors.verticalCenter: parent.verticalCenter
                text: outPutText
                font.pixelSize: 20
                color: "gray"
            }
            Rectangle
            {
                x:160
                anchors.bottom: parent.bottom
                width: parent.width/2
                height: 2
                color: "gray"
            }
        }
    }
    Rectangle {
        id:itemList
        width: parent.width-60
        height: parent.height - toolbar.height - titlebar.height-60
        y:titlebar.height+30
        anchors.horizontalCenter: parent.horizontalCenter
        Image {
            id: bg
            anchors.fill: parent
            source: "pics/myaccountbg.png"
            ListView{
                id:accountlist
                x:0
                y:30
                height: bg.height-60
                width: parent.width
                model: accountmodel
                delegate: accountItem
            }
        }
    }
    function dataFinished(errCode)
    {
        datadone = true;

        if(errCode != 200)
        {
            popup1.errorCode = errCode;
            popup1.visible = true;
        }
    }
    Component.onCompleted:{
        bookNetMgr.myAccountRequestResponse.connect(dataFinished);
        bookNetMgr.GetAccountInfo();
    }
}
