import QtQuick 1.0
import "controls"

Rectangle {
    id: myBookShelfQml
    anchors.fill: parent
    color: "#2C2C2C"
    property string selectedbookId
    property string selectedbookPath
    property string selectedbookIcon
    property string selectedbookName
    property string selectedbookAuthor
    property string selectedbookSize

    Component.onCompleted:
    {
        bookreader.emitDrmInfo.connect(myBookShelfQml.payPopup);
        myBookShelf.diskSpaceNotEnough.connect(myBookShelfQml.checkDiskSpace);
        myBookShelf.updateBookList();
        myBookShelf.checkDiskSpace();
    }

    Popupwith1buttonCustomContent{
        id:checkDiskSpacePopup
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        content: "抱歉，磁盘空间已满，请释放空间后再试"
        visible:false
        onClickbutton:
        {
            visible = false;
        }
    }

    Loading{
        id:freshLoadingPage
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        visible: false
    }

    Loadingwithclose{
        id:loadingpage
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        visible: false

        onClickclose: {
            bookNetMgr.CancelHttp();
            visible = false;
        }
    }
    Popupwith2button{
        id: purchasePopup
        visible: false
        bgwidth: parent.width
        bgheigh:parent.height
        z:200
        leftButtonText:"确定"
        rightButtonText:"取消"
        onClickleft: {
            loadingpage.visible = true;
            visible = false;
            if(bookreader.DoneBaseOnSingals() == 1)
            {
                loadingpage.visible = true;
            }
            else
            {
                loadingpage.visible = false;
            }
            pressleftbutton=true;
            pressrightbutton=false;
            visible = false;
        }
        onClickright:{
           pressleftbutton=true;
           pressrightbutton=false;
           visible = false;
        }
    }
    Popupwith1button{
        id:popup1
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        onClickbutton:{
            visible = false;
        }
    }
    Popupwith1buttonCustomContent{
        id:retPopup
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        onClickbutton:
        {
            visible = false;
        }
    }

    Popupwith1buttonCustomContent{
        id:failedRetPopup
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        content: "文件出错了"
        onClickbutton:
        {
            visible = false;
            myBookShelf.updateBookList();
        }
    }

    MyShelfList
    {
        id: bookList
        anchors.left: parent.left
        anchors.top: bookshelfTitleBar.bottom
        anchors.bottom: toolbar.top
        width: parent.width
        onLongPressBookItem:
        {
            bookPopupMenu.visible = true;
        }
    }

    AccTitleBar{
        id: bookshelfTitleBar
        anchors.top: parent.top
        anchors.left: parent.left
        titleBarWidth:parent.width
        titleBarHeight:50
        titleText: "河马读书"
        imgVisibleFlag: false
    }

    MyBookShelfToolBar
    {
        id: toolbar
        anchors.left: parent.left
        anchors.bottom: parent.bottom

        toolBarWidth:parent.width
        toolBarHeight:72
        bgImage:"../pics/toolbarbg.png"
        toolbarModel:toolbarModel
        hasBackButton: false
        onItemClicked:
        {
            switch(id)
            {
            case 1:
                {
                    ebookreadercontainer.lastpagenum = 0;
                    ebookreadercontainer.changePage(5);
                }
                break;
            case 2:
                {
                    ebookreadercontainer.lastpagenum = 0;
                    ebookreadercontainer.changePage(3);
                }
                break;
            case 3:
                {
                    moreList.visible = true;
                }
                break;
            default:
                break;
            }
        }
    }
    ListModel{
        id: toolbarModel
        ListElement {
            itemHighlightImg: "../pics/MybookHighLight.png"
            itemImg: "../pics/Mybook.png"
        }
        ListElement {
            itemHighlightImg: "../pics/bookshop_focus.png"
            itemImg: "../pics/bookshop.png"
        }
        ListElement {
            itemHighlightImg: "../pics/booksearch_focus.png"
            itemImg: "../pics/booksearch.png"
        }
        ListElement {
            itemHighlightImg: "../pics/selectmore_focus.png"
            itemImg: "../pics/selectmore.png"
        }
    }

    MyShelfMoreList
    {
        id: moreList
        anchors.fill: parent
        visible: false;
        onItemClicked:
        {
            switch(itemIndex)
            {       
            case 0:
                {
                    ebookreadercontainer.lastpagenum = 0;
                    ebookreadercontainer.changePage(9);
                }
                break;

            case 1:
                {
                    ebookreadercontainer.lastpagenum = 0;
                    ebookreadercontainer.changePage(8);
                }
                break;

            case 2:
                {
                    ebookreadercontainer.lastpagenum = 0;
                    ebookreadercontainer.changePage(11);
                }
                break;

            case 3:
                {
                    ebookreadercontainer.lastpagenum = 0;
                    ebookreadercontainer.changePage(10);
                }
                break;

            case 4:
                {
                    visible = false;
                    toolbar.setCurrentIndex(0);
                    break;
                }
            default:
                break;
            }
        }
    }

    PopupMenuWithULine{
        id: bookPopupMenu;
       visible: false
       bgwidth: parent.width
       bgheigh:parent.height
       textItemModel: menulist
       onClickedmenuitem: {
           visible = false;
           switch(clickindex)
           {
           case 0:
               {
                   switch(myBookShelf.openBook(myBookShelfQml.selectedbookId, myBookShelfQml.selectedbookPath))
                   {
                    case 0:
                        {
                            ebookreadercontainer.lastpagenum = 0;
                            ebookreadercontainer.changePage(1);
                        }
                        break;
                    case 1:
                        {
                        loadingpage.visible = true
                        }
                        break;
                    case 7:
                        {
                        loadingpage.visible = true
                        }
                        break;
                    default:
                        {
                            failedRetPopup.visible = true;
                            failedRetPopup.content = "文件出错了";
                        }
                        break;
                   }

               }
               break;
           case 1:
               {
                   bookDetailPopup.visible = true;
               }
               break;
           case 2:
               { 
                   deletePopup.visible = true;
               }
               break;
           default:
               break;
           }
       }
       onClickclose: {
           visible = false;
       }
    }
    ListModel
    {
           id: menulist
           ListElement
           {
               menutext:"打开书籍"
           }
           ListElement
           {
               menutext:"书籍属性"
           }
           ListElement
           {
               menutext:"删除本书"
           }
    }

    BookDetailPopup
    {
        id: bookDetailPopup
        visible: false
        bgwidth: parent.width
        bgheigh:parent.height
        booknamecontent: "《"+ myBookShelfQml.selectedbookName +"》"
        authornamecontent: myBookShelfQml.selectedbookAuthor
        sizenamecontent: myBookShelfQml.selectedbookSize
        pathnamecontent: myBookShelfQml.selectedbookPath
        onClickclose:
        {
           visible = false;
        }
    }

    Popupwith1buttonCustomContent{
        id:deleteFailedPopup
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        content: "删除失败"
        visible:false
        onClickbutton:
        {
            visible = false;
        }
    }

    Popupwith2button{
        id: deletePopup
        visible: false
        bgwidth: parent.width
        bgheigh:parent.height
        content: "是否立即删除 《" + myBookShelfQml.selectedbookName + "》"+"？"
        leftButtonText:"确定"
        rightButtonText:"取消"
        onClickleft: {
           pressleftbutton=true;
           pressrightbutton=false;
           visible = false;
           if(!myBookShelf.deleteBook(myBookShelfQml.selectedbookId,
                                      myBookShelfQml.selectedbookPath,
                                      myBookShelfQml.selectedbookIcon))
           {
                deleteFailedPopup.visible = true;
           }
        }
        onClickright:{
           pressleftbutton=true;
           pressrightbutton=false;
           visible = false;
        }
    }

    function payPopup(errorcode,status,textContent)
    {
        loadingpage.visible = false;
        purchasePopup.visible = false;
        retPopup.visible = false;
        if(errorcode == 200)
        {
            switch(status)
            {
            case 0:
                {
                myBookShelf.openBook(myBookShelfQml.selectedbookId, myBookShelfQml.selectedbookPath);
                ebookreadercontainer.lastpagenum = 0;
                ebookreadercontainer.changePage(1);
                    break;
                }
            case 1:
                {
                purchasePopup.content = textContent;
                purchasePopup.visible = true;
                    break;
                }
            case 2:
                {
                purchasePopup.content = textContent;
                purchasePopup.visible = true;
                    break;
                }
            case 3:
                {
                retPopup.content = "付费成功!"
                retPopup.visible = true;
                    break;
                }
            case 5:
                {
                retPopup.content = "付费失败!"
                retPopup.visible = true;
                    break;
                }
            default:
                {
                retPopup.content = "未知错误";
                retPopup.visible = true;
                    break;
                }
            }
        }
        else {
            popup1.errorCode = errorcode;
            popup1.visible = true;
        }

    }

    function checkDiskSpace()
    {
        checkDiskSpacePopup.visible = true;
    }
}
