import QtQuick 1.0

Rectangle {
    id: bookShelfListBg

    property int itemHeight: 108
    property int iconWidth: 61
    property int iconHeight:  88
    color: "transparent"

    signal longPressBookItem()
    Component
    {
        id: bookDelegate
        Item {
            id: bookItem
            width: bookShelfListBg.width
            height: itemHeight

            Rectangle
            {
                anchors.fill: parent

                Rectangle
                {
                    anchors.fill: parent
                    color: "#2C2C2C"
                }

                Rectangle
                {
                    anchors.left: parent.left
                    anchors.bottom: parent.bottom
                    anchors.leftMargin: 8
                    width: parent.width-16
                    height: 1
                    color: "#464646"
                }
                Image {
                    id: img_focus
                    anchors.fill: parent
                    source: "pics/bookshelfitem_focus.png"
                    visible: mouseArea.pressed
                }

                Image {
                    id: bookItemBg
                    x: 437
                    width: 9
                    height: 13
                    anchors.verticalCenter: parent.verticalCenter
                    source: "pics/bookShelf_indicator.png"
                }

                Image
                {
                    id: bookIcon
                    anchors.left: parent.left
                    anchors.verticalCenter: parent.verticalCenter
                    anchors.leftMargin: 23
                    width: iconWidth
                    height: iconHeight
                    source: iconPath
                }

                Image
                {
                    id: newIcon
                    anchors.left: parent.left
                    anchors.leftMargin: 60
                    anchors.top: bookIcon.top
                    visible: newIconFlag
                    fillMode: Image.PreserveAspectFit
                    source: "pics/newDownloadIcon.png"
                }


                Text {
                    anchors.left: bookIcon.right
                    anchors.leftMargin: 13
                    y: 25
                    height: 24
                    text: "《"+bookName+"》"
                    color: "white"
                    font.pixelSize: 24
                }

                Text {
                    anchors.left: bookIcon.right
                    anchors.leftMargin: 23
                    y: 60
                    height: 17
                    text: "作者: "+authorName
                    color: "white"
                    font.pixelSize: 18
                }
            }

            function setSelectItemInfo()
            {
                myBookShelfQml.selectedbookId = bookId;
                myBookShelfQml.selectedbookPath = bookPath;
                myBookShelfQml.selectedbookIcon = iconPath;
                myBookShelfQml.selectedbookName = bookName;
                myBookShelfQml.selectedbookSize = bookSize;
                myBookShelfQml.selectedbookAuthor = authorName;
            }

            MouseArea
            {
                id: mouseArea
                anchors.fill: parent
                onClicked:
                {
                    freshLoadingPage.visible = true;
                    bookItem.setSelectItemInfo();
                    switch(myBookShelf.openBook(myBookShelfQml.selectedbookId, myBookShelfQml.selectedbookPath))
                    {
                     case 0:
                         {
                             freshLoadingPage.visible = false;
                             ebookreadercontainer.lastpagenum = 0;
                             ebookreadercontainer.changePage(1);
                         }
                         break;
                     case 1:
                         {
                             freshLoadingPage.visible = false;
                             loadingpage.visible = true
                         }
                         break;
                     case 7:
                         {
                             freshLoadingPage.visible = false;
                             loadingpage.visible = true
                         }
                         break;
                     default:
                         {
                            freshLoadingPage.visible = false;
                             failedRetPopup.visible = true;
                             failedRetPopup.content = "文件出错了";
                         }
                         break;
                    }
                }
                onPressAndHold:
                {
                    bookItem.setSelectItemInfo();
                    longPressBookItem();
                }
            }
        }
    }


    ListView
    {
        id: itemlist
        anchors.fill: parent
        delegate: bookDelegate
        model: shelfListModel
        orientation: ListView.Vertical
        snapMode: ListView.SnapToItem;
        flickDeceleration: 2000
    }
}
