import QtQuick 1.0

Rectangle {
    id: morePageBg
    color: "transparent"
    property string closeImagePath: "pics/CloseIcon.png"
    property string closeClickedImagePath: "pics/CloseIconClicked.png"
    property bool clickedCloseFlag: false
    signal itemClicked(int itemIndex)

    Image{
        id:bg
        anchors.fill: parent
        source: "pics/PopupBG.png"
        MouseArea{
           anchors.fill: parent
        }
    }
    Rectangle {
        id: closeimage
        anchors.bottom:gLine.top
        anchors.bottomMargin: -20
        anchors.right: parent.right
        width:100
        height:100
        color: "transparent"
        Image{
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 30
            anchors.right: parent.right
            anchors.rightMargin: 50
            source: (clickedCloseFlag==false)? closeImagePath :closeClickedImagePath
        }
        MouseArea{
            anchors.fill: parent
            onPressed: {
                clickedCloseFlag = true;
            }
            onReleased: {
                clickedCloseFlag = false;
            }
            onClicked: {
                itemClicked(4);
            }
        }
    }

    Rectangle
    {
        id:gLine
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.bottom: moreList.top
        width: parent.width-40
        height: 2
        radius: 5
        color: "#92B638"
    }

    Component
    {
        id: itemDelegate
        Item
        {
            id: menuItem
            width: morePageBg.width
            height: 50
            Rectangle
            {
                anchors.fill: parent
                color: "transparent"
            }

            Image
            {
                id:marginfoucus
                anchors.fill: parent
                source: "pics/PopupSelectedHighLight.png"
                opacity: 0.8
                visible: mouseArea.pressed;
            }

            Text
            {
                anchors.left: parent.left
                anchors.leftMargin: 32
                anchors.verticalCenter: parent.verticalCenter
                text: itemText
                color: "white"
                font.pixelSize: 25
                smooth: true
            }

            MouseArea
            {
                id: mouseArea
                anchors.fill: parent
                onClicked:
                {
                    itemClicked(index);
                }
            }

        }
    }

    ListModel
    {
        id: menuModel

        ListElement
        {
            itemText: "我的帐户"
        }
        ListElement
        {
            itemText: "下载中心"
        }
        ListElement
        {
            itemText: "设置"
        }
        ListElement
        {
            itemText: "帮助"
        }
    }

    ListView
    {
            id: moreList
            anchors.left: parent.left
            y: 385
            width: parent.width
            height: 300
            delegate: itemDelegate
            model: menuModel
            interactive: false
    }
}

