import QtQuick 1.0
import "controls"

Rectangle {
    id:netshop
    anchors.fill: parent
    property bool datadone: false
    property bool firstEnter: true
    property bool detailerror: false
    Loadingwithclose{
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        visible: !datadone

        onClickclose: {
            bookNetMgr.CancelHttp();
            if(detailerror == false)
            {
                ebookreadercontainer.changePage(0);
            }
            detailerror = false;
            datadone = true;
        }
    }
    Popupwith1button{
        id:popup1
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        onClickbutton:{
            ebookreadercontainer.changePage(0);
        }
    }
    OnlineSearchingMoreList
    {
        id: moreList
        anchors.fill: parent
        visible: false;
        z:150
        onItemClicked:
        {
            switch(itemIndex)
            {
            case 0:
                {
                    visible = false;
                    toolbar.setCurrentIndex(1);
                    relist.closePanel();
                    ebookreadercontainer.changePage(9);
                    break;
                }
            case 1:
                {
                    visible = false;
                    toolbar.setCurrentIndex(1);
                    relist.closePanel();
                    ebookreadercontainer.changePage(8);
                    break;
                }
            case 2:
                {
                    visible = false;
                    toolbar.setCurrentIndex(1);
                    relist.closePanel();
                    ebookreadercontainer.changePage(11);
                    break;
                }
            case 3:
                {
                    visible = false;
                    toolbar.setCurrentIndex(1);
                    relist.closePanel();
                    ebookreadercontainer.changePage(10);
                    break;
                }
            case 4:
                {
                    visible = false;
                    relist.closePanel();
                    toolbar.setCurrentIndex(1);
                    break;
                }
            default:
                {
                    break;
                }
            }
        }
    }
    AccTitleBar{
        id:oldtitlebar
        x:0
        y:0
        z:100
        titleBarWidth:parent.width
        titleBarHeight:50
        titleText: "网上书城"
        imgVisibleFlag: false

    }
    MyBookShelfToolBar
    {
        id: toolbar
        z:100
        x:0
        anchors.bottom: parent.bottom
        defaultCurrentIndex: 1
        toolBarWidth:parent.width
        toolBarHeight:72
        bgImage:"../pics/toolbarbg.png"
        toolbarModel:toolbarModel
        hasBackButton: true
        onItemClicked:
        {
            switch(id)
            {
                case 0:
                    {
                        relist.closePanel();
                        ebookreadercontainer.changePage(0);
                        break;
                    }
                case 1:
                    break;
                case 2:
                    {
                        relist.closePanel();
                         ebookreadercontainer.changePage(3);
                        break;
                    }
                case 3:
                {
                    moreList.visible = true;
                    toolbar.setCurrentIndex(3);
                    break;
                }
                default:
                    break;
            }


        }
        onClickOnBack: {
            relist.closePanel();
            ebookreadercontainer.changePage(0);
        }
    }
    ListModel{
        id: toolbarModel
        ListElement {
            itemHighlightImg: "../pics/MybookHighLight.png"
            itemImg: "../pics/Mybook.png"
        }
        ListElement {
            itemHighlightImg: "../pics/bookshop_focus.png"
            itemImg: "../pics/bookshop.png"
        }
        ListElement {
            itemHighlightImg: "../pics/booksearch_focus.png"
            itemImg: "../pics/booksearch.png"
        }
        ListElement {
            itemHighlightImg: "../pics/selectmore_focus.png"
            itemImg: "../pics/selectmore.png"
        }
    }
    Rectangle {
        id:titlebar
        anchors.top: oldtitlebar.bottom
        width: parent.width
        height: 60
        z:1
        Image {
            anchors.fill: parent
            source: "pics/titlebg.png"
            Image {
                height: 60
                width: netshop.width/3
                anchors.horizontalCenter: parent.horizontalCenter
                source: "pics/titleselected.png"
            }
        }
        PathView {
            id:title
            width: parent.width
            anchors.verticalCenter: parent.verticalCenter
            anchors.horizontalCenter: parent.horizontalCenter
            model: titlemodelQt
            delegate: delegate
            preferredHighlightBegin: 0.5
            preferredHighlightEnd: 0.5
            pathItemCount : 3
            path: Path {
                startX: 40; startY: 0
                PathLine { x: netshop.width-40; y: 0 }
            }
        }
        Rectangle {
            width: 50
            height: parent.height
            anchors.top: parent.top
            anchors.left: parent.left
            color:"transparent"
            Image {
                id:leftbutton
                property bool click: false
                anchors.verticalCenter: parent.verticalCenter
                x:20
                source: {
                    if(click==false)
                        return "pics/titleleft.png";
                    else return "pics/titleleftclicked.png";
                }
            }
            MouseArea{
                anchors.fill: parent
                onPressed: {
                    leftbutton.click = true
                }
                onReleased: {
                    if(leftbutton.click == true){
                        relist.closePanel();
                        leftbutton.click = false;
                        title.decrementCurrentIndex();
                        if(bookNetMgr.GetOnlineBookInfo(titlemodelQt.getIdString(title.currentIndex),false))
                        {
                            dataFinished(200);
                        }
                        else
                        {
                            datadone = false;
                        }
                    }
                }
                onExited: {
                    leftbutton.click = false;
                }
            }
        }
        Rectangle {
            width: 50
            height: parent.height
            anchors.top: parent.top
            anchors.right: parent.right
            color:"transparent"
            Image {
                id:rightbutton
                property bool click: false
                anchors.verticalCenter: parent.verticalCenter
                x:parent.width-20-sourceSize.width
                source: {
                    if(click == false)
                        return "pics/titleright.png";
                    else return "pics/titlerightclicked.png";
                }
            }
            MouseArea{
                anchors.fill: parent
                onPressed: {
                    rightbutton.click = true
                }
                onReleased: {
                    if(rightbutton.click == true){
                        relist.closePanel();
                        rightbutton.click = false;
                        title.incrementCurrentIndex();
                        if(bookNetMgr.GetOnlineBookInfo(titlemodelQt.getIdString(title.currentIndex),false))
                        {
                            dataFinished(200);
                        }
                        else
                        {
                            datadone = false;
                        }
                    }
                }
                onExited: {
                    rightbutton.click = false;
                }
            }
        }

    }

    Component {
        id: delegate
        Rectangle{
            width: netshop.width/3
            height: 60
            color: "transparent"
            Text {
                anchors.centerIn: parent
                text: name
                font.pixelSize: 25
                color: {
                    if(title.currentIndex == index){
                        return "white"
                    }
                    else return "black"
                }
            }
            MouseArea{
                anchors.fill: parent
                onClicked: {
                    relist.closePanel();
                    title.currentIndex = index
                    if(bookNetMgr.GetOnlineBookInfo(titlemodelQt.getIdString(title.currentIndex),false))
                    {
                        dataFinished(200);
                    }
                    else
                    {
                        datadone = false;
                    }
                }
            }
        }
    }
    Rectangle {
        anchors.top: titlebar.bottom
        anchors.left: parent.left
        width: parent.width
        height: parent.height-titlebar.height-toolbar.height
        Flickable {
            anchors.fill: parent
            contentWidth : parent.width
            contentHeight : relist.height+bllist.height+toolbar.height
            interactive: true
            Recommendlist{
                id:relist
                anchors.top: parent.top
                anchors.left: parent.left
                listwidth: parent.width
                listheight: 254
                recomlistmodel:recomodelQt
            }
            Booklistlist{
                id:bllist
                anchors.top: relist.bottom
                anchors.left: parent.left
                listwidth: parent.width
                listheight: bookmodelQt.getHeight()+toolbar.height
                biglistmodel:bookmodelQt
            }
        }
    }
    Component.onCompleted:{
        bookNetMgr.onlineBookRequestResponse.connect(netshop.dataFinished);
        bookNetMgr.bookInfoRequestResponse.connect(netshop.readyTojump);
        if(bookNetMgr.GetOnlineBookInfo("",true))
        {
            dataFinished(200);
        }
        else
        {
            datadone = false;
        }
    }

    function dataFinished(errCode)
    {
        netshop.datadone = true;

        if(errCode != 200)
        {
            popup1.errorCode = errCode;
            popup1.visible = true;
        }
        else
        {
            if(firstEnter)
            {
                title.currentIndex = 0;
                firstEnter = false;
            }
            bllist.listheight = bookmodelQt.getHeight()+toolbar.height;
            relist.upDate();
        }
    }
    function readyTojump(errCode)
    {
        netshop.datadone = true;
        relist.closePanel();
        if(errCode != 200)
        {
            popup1.errorCode = errCode;
            popup1.visible = true;
        }
        else
        {
            ebookreadercontainer.changePage(6);
        }
    }

}
