import QtQuick 1.0
import "controls"

Rectangle {
    id: onlineSearchKeyListView
    anchors.fill: parent
    property int keyTextWidth: 154
    property int keyTextHeight: 35
    property int keyDelegateHeight: 55

    property bool datadone: false
    Loadingwithclose{
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        visible: !datadone
        onClickclose:
        {
            bookNetMgr.CancelHttp();
            ebookreadercontainer.changePage(0);
        }
    }

    Popupwith1button{
        id:popup1
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        onClickbutton:{
            ebookreadercontainer.changePage(0);
        }
    }

    MouseArea
    {
        anchors.fill: parent
        onClicked:
        {
            searchBar.closePanel();
        }
    }

    AccTitleBar
    {
        id: accTitleBar
        anchors.top: parent.top
        anchors.left: parent.left
        titleBarWidth:parent.width
        titleBarHeight:50
        titleText: "搜索"
        z: 2
        imgVisibleFlag: false
    }

    OnlineSearchBar
    {
        id: searchBar
        anchors.top:  accTitleBar.bottom
        anchors.left: parent.left
        width: parent.width
        height: 65
        z:1
        onInputIconClicked:
        {
            searchBar.closePanel();
            keySearchModel.handleSelectInputText(str);
            ebookreadercontainer.lastpagenum = 3;
            ebookreadercontainer.changePage(4);
        }
    }

    Component
    {
        id: keyDelegate
        Item
        {
            id: keyItem
            width: keyGrid.cellWidth
            height: keyGrid.cellHeight
            MouseArea
            {
                anchors.fill: parent
                onClicked:
                {
                    searchBar.closePanel();
                }
            }

            Rectangle
            {
                anchors.left: parent.left
                anchors.leftMargin: 50
                anchors.bottom: parent.bottom
                width: (keyTextWidth > keyWordText.width)?keyWordText.width:keyTextWidth
                height: keyTextHeight
                Text
                {
                    id: keyWordText
                    anchors.bottom: parent.bottom
                    text: "<u>" + keyword + "</u>"
                    color: (mouseArea.pressed)? "#B0DA45":"black"
                    font.pixelSize: 25
                }
                MouseArea
                {
                    id: mouseArea
                    anchors.fill: parent
                    onClicked:
                    {
                        searchBar.closePanel();
                        keySearchModel.handleKeyWordClick(index);
                        ebookreadercontainer.lastpagenum = 3;
                        ebookreadercontainer.changePage(4);
                    }
                }
            }
        }
    }

    GridView
    {
        id: keyGrid
        anchors.top: searchBar.bottom
        anchors.left: parent.left
        anchors.bottom: toolbar.top
        width: parent.width
        z: 0
        cellWidth: parent.width/2
        cellHeight: keyDelegateHeight
        delegate: keyDelegate
        model:keySearchModel
    }

    MyBookShelfToolBar
    {
        id: toolbar
        anchors.left: parent.left
        y: 782
        toolBarWidth:parent.width
        toolBarHeight:72
        bgImage:"../pics/toolbarbg.png"
        toolbarModel:toolbarModel
        defaultCurrentIndex: 2
        hasBackButton: true
        onItemClicked:
        {
            switch(id)
            {
            case 0:
                {
                    ebookreadercontainer.lastpagenum = 3;
                    ebookreadercontainer.changePage(0);
                    break;
                }
            case 1:
                {
                    ebookreadercontainer.lastpagenum = 3;
                    ebookreadercontainer.changePage(5);
                }
                break;
            case 2:
                break;
            case 3:
                moreList.visible = true;
                break;
            default:
                break;
            }


        }
        onClickOnBack:
        {
            searchBar.closePanel();
            ebookreadercontainer.lastpagenum = 3;
            ebookreadercontainer.changePage(0);
        }
    }
    ListModel{
        id: toolbarModel
        ListElement {
            itemHighlightImg: "../pics/MybookHighLight.png"
            itemImg: "../pics/Mybook.png"
            buttonText:"我的书架"
        }
        ListElement {
            itemHighlightImg: "../pics/bookshop_focus.png"
            itemImg: "../pics/bookshop.png"
            buttonText:"网上书城"
        }
        ListElement {
            itemHighlightImg: "../pics/booksearch_focus.png"
            itemImg: "../pics/booksearch.png"
            buttonText:"搜索"
        }
        ListElement {
            itemHighlightImg: "../pics/selectmore_focus.png"
            itemImg: "../pics/selectmore.png"
            buttonText:"更多"
        }
    }

    OnlineSearchingMoreList
    {
        id: moreList
        anchors.fill: parent
        z:1
        visible: false;
        onItemClicked:
        {
            switch(itemIndex)
            {
            case 0:
                {
                    ebookreadercontainer.lastpagenum = 3;
                    ebookreadercontainer.changePage(9);
                }
                break;

            case 1:
                {
                    ebookreadercontainer.lastpagenum = 3;
                    ebookreadercontainer.changePage(8);
                }
                break;

            case 2:
                {
                    ebookreadercontainer.lastpagenum = 3;
                    ebookreadercontainer.changePage(11);
                }
                break;

            case 3:
                {
                    ebookreadercontainer.lastpagenum = 3;
                    ebookreadercontainer.changePage(10);
                }
                break;

            case 4:
                {
                    visible = false;
                    toolbar.setCurrentIndex(2);
                    break;
                }
            default:
                {
                    break;
                }
            }
        }
    }

    Component.onCompleted:{
        searchMgrModel.searchKeyWordResponse.connect(onlineSearchKeyListView.dataFinished);
        searchMgrModel.getRecmmendKeywordList();
    }

    function dataFinished(errCode)
    {
        onlineSearchKeyListView.datadone = true;
        if(errCode != 200)
        {
            popup1.errorCode = errCode;
            popup1.visible = true;
        }
    }
}
