import QtQuick 1.0
import "controls"


Rectangle {
    id: onlineSearchResultListView
    anchors.fill: parent

    Loadingwithclose{
        id: initLoadingPopup
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        visible: true
        onClickclose:
        {
            bookNetMgr.CancelHttp();
            if(itemlist.count == 0)
            {
                ebookreadercontainer.changePage(ebookreadercontainer.searchResultLastNum);
            }
            else
            {

            }

            visible = false;
        }
    }

    Loadingwithclose{
        id: openLoadingPopup
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        detailcontent: "正在打开，请稍候…"
        visible: false
        onClickclose:
        {
            bookNetMgr.CancelHttp();
            visible = false;
        }
    }

    Popupwith1button{
        id:popup1
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        onClickbutton:{
            ebookreadercontainer.changePage(ebookreadercontainer.searchResultLastNum);
        }
    }

    MouseArea
    {
        anchors.fill: parent
        onClicked:
        {
            searchBar.closePanel();
        }
    }

    AccTitleBar
    {
        id: accTitleBar
        anchors.top: parent.top
        anchors.left: parent.left
        titleBarWidth:parent.width
        titleBarHeight:50
        titleText: "搜索"
        z: 2
        imgVisibleFlag: false
    }

    OnlineSearchBar
    {
        id: searchBar
        anchors.top:  accTitleBar.bottom
        anchors.left: parent.left
        width: parent.width
        height: 65
        z:1
        defaultText: resultSearchModel.getInputText()
        onInputIconClicked:
        {
            searchBar.closePanel();
            resultSearchModel.handleSearchButtonClicked(str);
            ebookreadercontainer.changePage(4);
        }
    }

    Rectangle
    {
        id: resultStr
        anchors.top: searchBar.bottom
        anchors.left: parent.left
        width: parent.width
        height: 40
        z: 1
        Image
        {
            anchors.fill: parent
            source: "pics/listtitle.png"
        }
        Text
        {
            id: searchText
            anchors.left: parent.left
            anchors.leftMargin: 20
            anchors.verticalCenter: parent.verticalCenter
            text: resultSearchModel.onlineResultTitle
            font.pixelSize: 20
        }
    }

    AccToolBar
    {
        id: toolbar
        anchors.left: parent.left
        y: 782
        z:1
        toolBarWidth:parent.width
        toolBarHeight:72
        bgImage:"../pics/toolbarbg.png"
        toolbarModel:toolbarModel
        hasBackButton: true

        onItemClicked:
        {
            switch(id)
            {
            case 0:
                {
                ebookreadercontainer.lastpagenum = 4;
                ebookreadercontainer.changePage(0);
                break;
                }
            default:
                break;
            }
        }
        onClickOnBack: {
            searchBar.closePanel();
            ebookreadercontainer.lastpagenum = 4;
            ebookreadercontainer.changePage(ebookreadercontainer.searchResultLastNum);
        }
    }
    ListModel{
        id: toolbarModel
        ListElement {
            itemHighlightImg: "../pics/MybookHighLight.png"
            itemImg: "../pics/Mybook.png"
        }
    }

    Component
    {
        id: resultDelegate
        Item {
            id: bookItem
            width: parent.width
            height: 100

            Rectangle
            {
                anchors.fill: parent

                Rectangle
                {
                    anchors.fill: parent
                    color: "#FBFBFB"
                }

                Rectangle
                {
                    anchors.left: parent.left
                    anchors.bottom: parent.bottom
                    anchors.leftMargin: 8
                    width: parent.width-16
                    height: 1
                    color: "#C6C6C6"
                }

                Image {
                    id: img_focus
                    anchors.fill: parent
                    source: "pics/IndexSelected.png"
                    visible: mouseArea.pressed
                }

                Image {
                    id: bookItemBg
                    x: 434
                    width: 9
                    height: 13
                    anchors.verticalCenter: parent.verticalCenter
                    source: "pics/onlineSearch_indicator.png"
                }

                Image
                {
                    id: bookIcon
                    anchors.left: parent.left
                    anchors.verticalCenter: parent.verticalCenter
                    anchors.leftMargin: 26
                    width: 53
                    height: 75
                    source: iconPath
                }


                Text {
                    id: bookNameText
                    anchors.left: bookIcon.right
                    anchors.leftMargin: 13
                    y: 18
                    height: 18

                    text: "《"+bookName+"》"
                    color: "black"
                    font.pixelSize: 20
                }

                Text {
                    id: authorText
                    anchors.left: bookIcon.right
                    anchors.leftMargin: 23
                    y: 45
                    height: 15
                    visible:
                    {
                        if(authorName == "")
                        {
                            return false;
                        }
                        else
                        {
                            return true;
                        }
                    }
                    text: "作者: "+authorName
                    color: "black"
                    font.pixelSize: 15
                }

                Text {
                    id: presentationText
                    anchors.left: bookIcon.right
                    anchors.leftMargin: 23
                    y: 65
                    height: 15

                    text: presentation
                    color: "black"
                    font.pixelSize: 15
                }

            }

            MouseArea
            {
                id: mouseArea
                anchors.fill: parent
                onClicked:
                {
                    searchBar.closePanel();
                    bookNetMgr.GetBookInfo(bookID);
                    openLoadingPopup.visible = true;
                    bookNetMgr.GetBookInfo(resultSearchModel.getBookID(index));
                }
            }
        }
    }

    ListView
    {
        id:itemlist
        anchors.top: resultStr.bottom
        anchors.bottom: toolbar.top
        anchors.left: parent.left
        width: parent.width
        delegate: resultDelegate
        model: resultSearchModel

        onMovementEnded:
        {

            if(itemlist.count != 0)
            {
                if (itemlist.atYBeginning)
                {
                    if(!resultSearchModel.pageUpGrayFlag)
                    {
                        if(resultSearchModel.handlePageup())
                        {
                           initLoadingPopup.visible = true;
                        }
                    }
                }
                else if(itemlist.atYEnd)
                {
                    if(!resultSearchModel.pageDownGrayFlag)
                    {
                        if(resultSearchModel.handlePagedown())
                        {
                            initLoadingPopup.visible = true;
                        }
                    }
                }
            }
        }

    }

    Component.onCompleted:
    {
        searchMgrModel.searchResultResponse.connect(onlineSearchResultListView.dataFinished);
        bookNetMgr.bookInfoRequestResponse.connect(onlineSearchResultListView.readyTojump);
        searchMgrModel.getSearchResultList();
    }

    function dataFinished(errCode)
    {
        initLoadingPopup.visible = false;
        if(errCode != 200)
        {
            popup1.errorCode = errCode;
            popup1.visible = true;
        }
    }

    function readyTojump(errCode)
    {
        openLoadingPopup.visible = false;
        if(errCode != 200)
        {
            popup1.errorCode = errCode;
            popup1.visible = true;
        }
        else
        {
            ebookreadercontainer.lastpagenum = 4;
            ebookreadercontainer.changePage(6);
        }
    }

}
