import QtQuick 1.0
import "controls"

Rectangle {
    id:readingpage
    anchors.fill: parent
    property bool fullscreen : false
    property bool mouseable: true
    property bool slide:  false
    property int oldx: 0
    property bool isNextPage: true
    property bool titleBarVisible: true
    Image {
        anchors.fill: parent
        source: "pics/ReadingBg.png"
    }
    Loadingwithclose{
        id:loadingpage
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        visible: false

        onClickclose: {
            bookreader.CancleDrmPurchase();
            bookNetMgr.CancelHttp();
            visible = false;
        }
    }
    Popupwith1button{
        id:popup1
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        onClickbutton:{
            bookreader.CancleDrmPurchase();
            visible = false;
        }
    }
    Popupwith2button{
        id: purchasePopup
        visible: false
        bgwidth: parent.width
        bgheigh:parent.height
        z:200
        leftButtonText:"确定"
        rightButtonText:"取消"
        onClickleft: {
            loadingpage.visible = true;
            visible = false;
            if(bookreader.DoneBaseOnSingals() == 1)
            {

                loadingpage.visible = true;
            }
            else
            {
                loadingpage.visible = false;
            }

            pressleftbutton=true;
            pressrightbutton=false;
            visible = false;
        }
        onClickright:{
            pressleftbutton=true;
            pressrightbutton=false;
            visible = false;
            bookreader.CancleDrmPurchase();
        }
    }
    Popupwith1buttonCustomContent{
        id:retPopup
        z:200
        bgwidth:parent.width
        bgheigh:parent.height
        buttonText: "确认"
        visible:false
        onClickbutton:
        {
            bookreader.DrmPurchaseOK();
            visible = false;
        }
    }
    Timer{
        id:clicktimer
        interval : 450
        repeat : false
        running : false
        onTriggered: {
            mouseable = true;
        }
    }

    BookPage {
        id:page1
        x:0
        y:0
        z:2
        angles:-90
        pagewidth: parent.width
        pageheight: parent.height
        titleheight:titlebar.height
        visible: false
    }
    BookPage {
        id:page2
        x:0
        y:0
        z:1
        angles:0
        pagewidth: parent.width
        pageheight: parent.height
        titleheight:titlebar.height
    }
    BookPage {
        id:page3
        x:0
        y:0
        z:0
        angles:0
        pagewidth: parent.width
        pageheight: parent.height
        titleheight:titlebar.height
    }

    MouseArea{
        x:0
        y:titlebar.height-20
        width: parent.width/2
        height: page1.height-20

        onPressed: {
            oldx = mouseX;
            slide = true;
        }
        onReleased: {
            if( slide==true && oldx == mouseX )
            {
                prePage();
            }
            slide = false;
        }
        onPositionChanged:{
            if(slide == true){
                if(mouseX > oldx+50)
                {
                    prePage();
                    slide  = false;
                }
                if(mouseX < oldx -50)
                {
                    nextPage();
                    slide  = false;
                }
            }
        }
    }
    MouseArea{
        x:parent.width/2
        y:titlebar.height-20
        width: parent.width/2
        height: page1.height-20
        onPressed: {
            oldx = mouseX;
            slide = true;
        }
        onReleased: {
            if( slide==true && oldx == mouseX )
            {
                nextPage();
            }
            slide = false;
        }
        onPositionChanged:{
            if(slide == true){
                if(mouseX > oldx+50)
                {
                    prePage();
                    slide  = false;
                }
                if(mouseX < oldx -50)
                {
                    nextPage();
                    slide  = false;
                }
            }
        }
    }
    MouseArea{
        x:0
        y:parent.height/3
        z:50
        width: parent.width
        height: parent.height/3
        onPressed: {
            oldx = mouseX;
            slide = true;
        }
        onReleased: {
            if( slide==true && oldx == mouseX )
            {
                switchscreen();
            }
            slide = false;
        }
        onPositionChanged:{
            if(slide == true){
                if(mouseX > oldx+50)
                {
                    prePage();
                    slide  = false;
                }
                if(mouseX < oldx -50)
                {
                    nextPage();
                    slide  = false;
                }
            }
        }
    }
    AccTitleBar{
        id:titlebar
        x:0
        y:0
        z:100
        titleBarWidth:parent.width
        titleBarHeight:50
        titleText: " "+listItemModel.getBookName()
        imgVisibleFlag: false
        titleBarVisibleFlag:titleBarVisible;
    }
    AccToolBar{
        id:toolbar
        x:0
        y:parent.height-toolbar.height
        z:100
        toolBarWidth:parent.width
        toolBarHeight:72
        bgImage:"../pics/toolbarbg.png"
        toolbarModel:toolbarModel
        highlightBgImage:"../pics/highlight.png"
        hasBackButton: true
        onItemClicked:{
            switch(id)
            {
                case 0:
                {
                    bookreader.StartUpListView();
                    ebookreadercontainer.changePage(0);
                }
                    break;
                case 1:
                {
                    bookreader.StartUpListView();
                    ebookreadercontainer.changePage(2);
                }
                    break;
                case 2:
                    saveBookMark();
                    break;
                case 3:
                    break;
                default:
                    break;
            }
        }
        onClickOnBack: {
            bookreader.StartUpListView();
            ebookreadercontainer.changePage(0);
        }
    }
    IndicateImage{
        z:200
    }
    ListModel{
        id: toolbarModel
        ListElement {
            itemHighlightImg: "../pics/MybookHighLight.png"
            itemImg: "../pics/Mybook.png"
        }
        ListElement {
            itemHighlightImg: "../pics/indexHighLight.png"
            itemImg: "../pics/index.png"
        }
        ListElement {
            itemHighlightImg: "../pics/bookmarkHighLight.png"
            itemImg: "../pics/bookmark.png"
        }
    }
    function nextPage()
    {
        isNextPage = true;
        if(mouseable&&(!bookreader.IsTheLastPage()))
        {
            mouseable = false
            var errCode = bookreader.GetNextOnePageContent();
            switch(errCode)
            {
            case 0:
                {
                page1.nextPage();
                page2.nextPage();
                page3.nextPage();
                    break;
                }
            case 1:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }
            case 2:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }
            case 3:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }
            case 4:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }
            case 5:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }
            case 6:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }
            case 7:
                {
                loadingpage.visible = true
                break;
                }
            case 8:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }
            default:
                {
                retPopup.content = "未知错误"
                retPopup.visible = true;
                    break;
                }
            }
            clicktimer.running = true;
        }
    }
    function prePage()
    {
        isNextPage = false;
        if(mouseable&&(!bookreader.IsTheFistPage()))
        {
            mouseable = false
            var errCode = bookreader.GetPreOnePageContent();
            switch(errCode)
            {
            case 0:
                {
                page1.previousPage();
                page2.previousPage();
                page3.previousPage();
                    break;
                }
            case 1:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }
            case 2:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }
            case 3:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }
            case 4:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }
            case 5:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }
            case 6:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }
            case 7:
                {
                loadingpage.visible = true
                break;
                }
            case 8:
                {
                retPopup.content = "文件出错了"
                retPopup.visible = true;
                break;
                }

            default:
                {
                retPopup.content = "未知错误"
                retPopup.visible = true;
                    break;
                }
            }
            clicktimer.running = true;
        }
    }
    function switchscreen()
    {
        if(fullscreen==false)
        {
            toolbar.y = parent.height;
            titlebar.y = -titlebar.height;
            fullscreen = true;
            titleBarVisible = false;
        }
        else if(fullscreen==true)
        {
            toolbar.y = parent.height-toolbar.height;
            titlebar.y = 0;
            fullscreen = false;
            titleBarVisible = true;
        }
    }
    function saveBookMark()
    {
            page1.hasbm = bookreader.SaveBookMrak();
            page2.hasbm = page1.hasbm;
            page3.hasbm = page1.hasbm;
    }
    function payPopup(errorcode,status,textContent)
    {
        loadingpage.visible = false;
        purchasePopup.visible = false;
        retPopup.visible = false;
        if(errorcode == 200)
        {
            switch(status)
            {
            case 0:
                {
                if(isNextPage == true)
                    nextPage();
                else prePage();
                    break;
                }
            case 1:
                {
                purchasePopup.content = textContent;
                purchasePopup.visible = true;
                    break;
                }
            case 2:
                {
                purchasePopup.content = textContent;
                purchasePopup.visible = true;
                    break;
                }
            case 3:
                {
                retPopup.content = "付费成功!"
                retPopup.visible = true;
                    break;
                }
            case 5:
                {
                loadingpage.visible = false;
                retPopup.content = "付费失败!"
                retPopup.visible = true;
                    break;
                }
            default:
                {
                retPopup.content = "未知错误";
                retPopup.visible = true;
                    break;
                }
            }
        }
        else {
            popup1.errorCode = errorcode;
            popup1.visible = true;
        }

    }

    Component.onCompleted: {
        bookreader.emitDrmInfo.connect(readingpage.payPopup);
        page2.firstEnter();
        page2.hasbm = bookreader.IsBookMark();
    }
}
