import QtQuick 1.0

Rectangle {
    property int listwidth: 480
    property int listheight: 254
    property variant recomlistmodel
    property int oldx
    property int newx
    property bool slide:false
    signal upDate
    width: listwidth
    height: listheight
    Image {
        anchors.fill: parent
        source: "pics/netshopbg.png"
    }

    PathView {
        id:list
        width: parent.width
        y:29
        anchors.horizontalCenter: parent.horizontalCenter
        model: recomlistmodel
        delegate: delegate
        preferredHighlightBegin: 0.5
        preferredHighlightEnd: 0.5
        pathItemCount : 5
        path: Path {
            startX: 30; startY: 50
            PathLine{x: list.width-30;y:50}
       }
    }
    Component {
        id: delegate
        Item {
            width: 82
            height: 200
            Rectangle{
                id:norPic
                width: {if(index == (list.currentIndex+1)%5 || index == (list.currentIndex+4)%5) return 82*0.83
                    if(index == (list.currentIndex+3)%5 || index == (list.currentIndex+2)%5) return 82*0.73
                    else return 82}
                height: {if(index == (list.currentIndex+1)%5 || index == (list.currentIndex+4)%5) return 118*0.83
                    if(index == (list.currentIndex+3)%5 || index == (list.currentIndex+2)%5) return 118*0.73
                    else return 118}
                x:{if(index == (list.currentIndex+1)%5) return (parent.width-width)/2+5
                    if(index == (list.currentIndex+4)%5) return (parent.width-width)/2-5
                    else return (parent.width-width)/2}
                y:(parent.height-height)*5/6
                color: "transparent"
                Image {
                    anchors.fill: parent
                    source: "pics/dai.png"
                }
                Image {
                    anchors.fill: parent
                    source: picpath
                }
            }
            Rectangle{
                id:mirPic
                width: {if(index == (list.currentIndex+1)%5 || index == (list.currentIndex+2)%5) return norPic.width
                    if(index == (list.currentIndex+3)%5 || index == (list.currentIndex+4)%5) return norPic.width
                    else return norPic.width}
                height: norPic.height*2/3
                anchors.top: norPic.bottom
                anchors.topMargin: 5
                x:{if(index == (list.currentIndex+1)%5 || index == (list.currentIndex+2)%5) return norPic.x
                    if(index == (list.currentIndex+3)%5 || index == (list.currentIndex+4)%5) return norPic.x
                    else return 0}
                color: "transparent"
                opacity: 0.6
                Image {
                    anchors.fill: parent
                    source: "pics/dai.png"
                }
                Image {
                    anchors.fill: parent
                    source: picpath
                }
                transform: Rotation {
                    origin.x: mirPic.width / 2
                    origin.y: mirPic.height /2
                    axis.x: 1; axis.y: 0; axis.z: 0
                    angle: 180
                }
            }

            MouseArea{
                anchors.fill: parent
                onPressed: {
                    oldx = mouseX;
                    slide = true;
                }
                onReleased: {
                    newx = mouseX;
                    if( slide==true && oldx == newx )
                    {
                        closePanel()
                        if(list.currentIndex != index)
                        {
                            list.currentIndex = index
                            bookname.text = recomlistmodel.getRecName(list.currentIndex);
                        }
                        else
                        {
                            bookNetMgr.GetBookInfo(recomlistmodel.getBookID(index));
                            netshop.detailerror = true;
                            netshop.datadone = false;
                        }
                    }
                    slide = false;
                }
                onPositionChanged:{
                    if(slide == true){
                        if(mouseX > oldx+30)
                        {
                            list.decrementCurrentIndex();
                            bookname.text = recomlistmodel.getRecName(list.currentIndex);
                            slide  = false;
                        }
                        if(mouseX < oldx -30)
                        {
                            list.incrementCurrentIndex();
                            bookname.text = recomlistmodel.getRecName(list.currentIndex);
                            slide  = false;
                        }
                    }
                }
                onExited: {
                    slide = false;
                }
            }
        }
    }

    Image {
        anchors.fill: parent
        source: "pics/recommendMask.png"
    }
    Rectangle {
        anchors.horizontalCenter: parent.horizontalCenter
        y:parent.height-bookname.paintedHeight-10
        width: parent.width/2
        color: "transparent"
        Text {
            id: bookname
            anchors.centerIn: parent
            text: recomlistmodel.getRecName(list.currentIndex);
            color: "white"
            font.pixelSize: 22
        }
    }

    onUpDate: {
        list.currentIndex = 0;
        bookname.text = recomlistmodel.getRecName(list.currentIndex);
    }

    function closePanel()
    {
        ebookreadercontainer.lastpagenum = 5
    }
}
