import QtQuick 1.0
import "controls"

import com.nokia.meego 1.0
Rectangle {
    id:settingView
    anchors.fill: parent
    Image{
        id:background
        source: "pics/bookshelf_title.png"
        height: parent.height
        width: parent.width+4
        z:parent.z+1
    }

    AccTitleBar{
        id:settingViewtitlebar
        x:0
        y:0
        titleBarWidth:parent.width
        titleBarHeight:50
        titleText: "设置"
        z:background.z+20
        imgVisibleFlag: false
    }

    AccToolBar{
        id:toolbar
        x:0
        y:parent.height-toolbar.height
        z:100
        toolBarWidth:parent.width
        toolBarHeight:72
        bgImage:"../pics/toolbarbg.png"
        highlightBgImage:"../pics/highlight.png"
        hasBackButton: true
        onClickOnBack: {
            saveConfiguation();
            if(ebookreadercontainer.lastpagenum==0){
                ebookreadercontainer.changePage(0);
            }
            else if(ebookreadercontainer.lastpagenum==5){
                ebookreadercontainer.changePage(5);
            }
            else if(ebookreadercontainer.lastpagenum==3){
                ebookreadercontainer.changePage(3);
            }
            else{
                ebookreadercontainer.changePage(0);
            }
        }
    }
    Rectangle{
        id:duplicationDownloadInfor
        anchors.top: settingViewtitlebar.bottom
        height: 80
        width: parent.width
        color: "transparent"
        z:background.z+1
        Text{
            id:infotext
            text: "书籍重复下载提示"
            color: "white"
            font.pixelSize: 25
            anchors.left: parent.left
            anchors.rightMargin: 60
            anchors.leftMargin: 20
            anchors.verticalCenter: parent.verticalCenter
        }

        Switch {
            id: duplicationInforSwitch
            checked: true

            anchors.right: parent.right
            anchors.rightMargin: 30
            anchors.verticalCenter: parent.verticalCenter

            onCheckedChanged: {
                saveConfiguation();
            }
        }
    }
    Component.onCompleted:{
        getConfiguation();
    }
    function getConfiguation(){
       duplicationInforSwitch.checked=ebooksetting.getIsNotifyUserOverwriteDL();
    }
    function saveConfiguation(){
        ebooksetting.setIsNotifyUserOverwriteDL(duplicationInforSwitch.checked);
    }
}
