import Qt 4.7

Rectangle {
    id:container

    property int bgwidth:parent.width
    property int bgheigh:parent.height
    property string booknamecontent: "no content"
    property string authornamecontent: "no content"
    property string sizenamecontent: "no content"
    property string pathnamecontent: "no content"
    property string closeImagePath: "../pics/CloseIcon.png"
    property string closeClickedImagePath: "../pics/CloseIconClicked.png"
    property string backgroundImagePath: "../pics/PopupBG.png"
    property string lineImagePath: "../pics/PopupGreenLine.png"
    property bool clickedCloseFlag: false

    width: bgwidth
    height: bgheigh
    color: "transparent"

    signal clickclose

    Image{
        id:bg
        x:0
        y:0
        width: container.bgwidth
        height: container.bgheigh
        source: backgroundImagePath
        MouseArea{
           anchors.fill: parent
        }
    }
    Rectangle {
        id: closeimage
        x:container.width-100
        y:line.y-80
        width: 100
        height: 100
        color: "transparent"
        Image{
            anchors.right: parent.right
            anchors.bottom: parent.bottom
            anchors.rightMargin: 40
            anchors.bottomMargin: 30
            source: (clickedCloseFlag==false)? closeImagePath :closeClickedImagePath
        }
        MouseArea{
            anchors.fill: parent
            onPressed: {
                clickedCloseFlag = true;
            }
            onReleased: {
                clickedCloseFlag = false;
            }
            onClicked: {
                container.clickclose();
            }
        }
    }
    Image{
        id:line
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.bottom: detailborder.top
        width: container.bgwidth-20
        source: lineImagePath
    }

    Rectangle {
        id:detailborder
        width: bgwidth
        color: "transparent"
        height: bookname.height+authorname.height+sizename.height+pathname.height
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.verticalCenter: parent.verticalCenter
        Text{
            id:booknametitle
            x:20
            anchors.top: detailborder.top
            anchors.topMargin: 10
            height:bookname.height
            text:"书名 ： "
            color: "white"
            font.pixelSize: 25
        }
        Text {
           id:bookname
           anchors.top: detailborder.top
           anchors.topMargin: 10
           anchors.left: booknametitle.right
           anchors.right: parent.right
           anchors.rightMargin: 20
           text:booknamecontent
           color: "white"
           font.pixelSize: 25
           wrapMode: Text.WrapAnywhere
        }
        Text{
            id:authornametitle
            x:20
            anchors.top: booknametitle.bottom
            height:authorname.height
            text:"作者 ： "
            color: "white"
            font.pixelSize: 25
        }
        Text {
           id:authorname
           anchors.top:bookname.bottom
           anchors.left: authornametitle.right
           anchors.right: parent.right
           anchors.rightMargin: 20
           text:authornamecontent
           color: "white"
           font.pixelSize: 25
           wrapMode: Text.WrapAnywhere
        }
        Text{
            id:sizenametitle
            x:20
            anchors.top: authornametitle.bottom
            height:sizename.height
            text:"大小 ： "
            color: "white"
            font.pixelSize: 25
        }
        Text {
           id:sizename
           anchors.top:authorname.bottom
           anchors.left: sizenametitle.right
           anchors.right: parent.right
           anchors.rightMargin: 20
           text:sizenamecontent
           color: "white"
           font.pixelSize: 25
           wrapMode: Text.WrapAnywhere
        }
        Text{
            id:pathnametitle
            x:20
            anchors.top: sizenametitle.bottom
            height:pathname.height
            text:"存储位置 ： "
            color: "white"
            font.pixelSize: 25
        }
        Text {
           id:pathname
           anchors.top:sizename.bottom
           anchors.left: pathnametitle.right
           anchors.right: parent.right
           anchors.rightMargin: 20
           text:pathnamecontent
           color: "white"
           font.pixelSize: 25
           wrapMode: Text.WrapAnywhere
        }
    }
}
