﻿import Qt 4.7

Rectangle {
    id:container
    anchors.fill: parent

    property int bgwidth:parent.width
    property int bgheigh:parent.width
    property string closeImagePath: "../pics/CloseIcon.png"
    property string closeClickedImagePath: "../pics/CloseIconClicked.png"
    property string backgroundImagePath: "../pics/PopupBG.png"
    property string animatedimagepath: "../pics/loading.png"
    property string detailcontent: "请稍候..."
    property bool clickedCloseFlag: false

    width: bgwidth
    height: bgheigh
    color: "transparent"
    signal clickclose
    Image{
        id:bg
        x:0
        y:0
        width: container.bgwidth
        height: container.bgheigh
        source: backgroundImagePath
        MouseArea{
           anchors.fill: parent
        }
    }

    Rectangle {
        id: closeimage
        anchors.bottom:upline.top
        anchors.bottomMargin: -20
        anchors.right: parent.right
        width:100
        height:100
        color: "transparent"
        Image{
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 30
            anchors.right: parent.right
            anchors.rightMargin: 50
            source: (clickedCloseFlag==false)? closeImagePath :closeClickedImagePath
        }
        MouseArea{
            anchors.fill: parent
            onPressed: {
                clickedCloseFlag = true;
            }
            onReleased: {
                clickedCloseFlag = false;
            }
            onClicked: {
                container.clickclose();
            }
        }
    }
    Image{
        id: upline
        anchors.bottom:roatcycle.top
        anchors.bottomMargin: 20
        anchors.horizontalCenter : parent.horizontalCenter
        width: container.bgwidth-20
        source:"../pics/PopupGreenLine.png"
    }

    Image {
        id: roatcycle
        anchors.verticalCenter: container.verticalCenter
        anchors.horizontalCenter : container.horizontalCenter
        property int index: 1
        source: "../pics/0" + index + ".png"
        smooth: true

        NumberAnimation on index {
            from: 1; to: 4
            duration: 1200
            running: roatcycle.visible && timemodel.activeFlag
            loops: Animation.Infinite
        }
    }

    Text{
        id:inloading
        anchors.top:roatcycle.bottom
        anchors.topMargin: 5
        anchors.horizontalCenter : container.horizontalCenter
        text:detailcontent
        font.pixelSize: 25
        color: "white"
        wrapMode: Text.WrapAnywhere
    }

}
