import QtQuick 1.0
import com.nokia.meego 1.0

Rectangle
{
    property string defaultText: ""
    signal inputIconClicked(string str)
    color: "#696566"

    Image {
        id: searchIcon
        anchors.centerIn: parent
        source: "../pics/onlineSearchBar.png"
    }

    Rectangle
    {
        anchors.verticalCenter:parent.verticalCenter
        x: 16
        y: 16
        width: 448
        height: 44
        color: "transparent"
        radius: 5
        TextField
        {
            id: textInput
            anchors.fill: parent
            anchors.verticalCenter:parent.verticalCenter
            text: defaultText
            platformStyle: TextFieldStyle { paddingRight: searchbarIcon.width+20 }
            Image {
                id: searchbarIcon
                anchors.verticalCenter: parent.verticalCenter
                anchors.right: parent.right
                anchors.rightMargin:20
                width: sourceSize.width
                height: sourceSize.height
                source: "../pics/searchbar.png"
                MouseArea
                {
                    id: searchIconMouseArea
                    anchors.centerIn: parent
                    width: 60
                    height: parent.height+10
                    onClicked:
                    {
                        inputIconClicked(textInput.text);
                    }
                }

            }
            Image {
                id: focusIcon
                anchors.centerIn: searchbarIcon
                source: "../pics/searchbar_focus.png"
                visible: searchIconMouseArea.pressed
            }
        }
    }



    function closePanel()
    {
        textInput.closeSoftwareInputPanel();
        textInput.focus = false;
    }
}
