import Qt 4.7

Rectangle {
    id:container

    property int bgwidth:parent.width
    property int bgheigh:parent.height
    property string closeImagePath: "../pics/CloseIcon.png"
    property string closeClickedImagePath: "../pics/CloseIconClicked.png"
    property string backgroundImagePath: "../pics/PopupBG.png"
    property variant textItemModel
    property int defaultCurrentIndex: 0
    property string lineImagePath: "../pics/PopupGreenLine.png"
    property bool  clickedCloseFlag: false

    width: bgwidth
    height: bgheigh
    color: "transparent"

    signal clickclose
    signal clickedmenuitem(int clickindex)
    function setCurrentIndex(index)
    {
         menuitemtext.currentIndex = index;
    }

    Image{
        id:bg
        x:0
        y:0
        width: container.bgwidth
        height: container.bgheigh
        source: backgroundImagePath
        MouseArea{
           anchors.fill: parent
        }
    }
    Rectangle {
        id: closeimage
        x:container.width-80
        y:container.height/3-20
        width: 100
        height:100
        color: "transparent"
        Image{
            anchors.bottom: closeimage.bottom
            anchors.right: closeimage.right
            anchors.rightMargin: 60
            anchors.bottomMargin: 30
            source: (clickedCloseFlag==false)? closeImagePath :closeClickedImagePath
        }
        MouseArea{
            anchors.fill: parent
            onPressed: {
                clickedCloseFlag = true;
            }
            onReleased: {
                clickedCloseFlag = false;
            }

            onClicked: {
                container.clickclose();
            }
        }
    }

    Image{
        id: upline
        anchors.horizontalCenter: parent.horizontalCenter
        y:closeimage.y+closeimage.height-20
        width: container.bgwidth-20
        source:lineImagePath
    }

    Component{
           id: sectionHeading
           Item{
               id:stringitem
               width: container.width-40;
               height: 50
               Rectangle {
                   id:roundborder
                   width: container.width-40
                   height: parent.height
                   color: "transparent"
                   Text {
                       x:upline.x
                       width: container.width-40
                       anchors.verticalCenter: parent.verticalCenter
                       color: "white"
                       font.pixelSize: 25
                       text: menutext
                      }
               }
               MouseArea{
                    anchors.fill: parent
                    onPressed: {
                        menuitemtext.currentIndex=index;
                    }
                    onClicked: {
                        menuitemtext.currentIndex=index;
                        container.clickedmenuitem(index);
                        menuitemtext.currentIndex=0;
                    }
                }
           }
          }
    Rectangle{
        id:listRound
        x:0
        y:upline.y+upline.height+5
        width: container.bgwidth
        color: "transparent"
        ListView{
                id: menuitemtext
                width: listRound.width
                anchors.fill: parent
                model: textItemModel

                orientation: ListView.Vertical
                focus:true
                currentIndex:defaultCurrentIndex
                interactive: false
                delegate:sectionHeading
                highlight: Component {
                    id: highlight
                    Image {
                    height: 50
                    width: container.width
                    smooth: true
                    source: "../pics/PopupSelectedHighLight.png"
                    opacity: 0.8
                    z:sectionHeading.z+1
                  }
              }
            }
         height: menuitemtext.count==0? 50:50*menuitemtext.count
    }
}
