import Qt 4.7

Rectangle {
    id:container

    property int bgwidth:parent.width
    property int bgheigh:parent.height
    property int errorCode:0

    property string buttonText: "button"
    property string buttonFocusOnImagePath: "../pics/PopupFocusOnButton.png"
    property string buttonFocusOffImagePath: "../pics/PopupFocusOffButton.png"
    property string backgroundImagePath: "../pics/PopupBG.png"
    property string lineImagePath: "../pics/PopupGreenLine.png"
    property bool pressbutton: false

    width: bgwidth
    height: bgheigh
    color: "transparent"

    signal clickbutton

    Image{
        id:bg
        x:0
        y:0
        width: container.bgwidth
        height: container.bgheigh
        source: backgroundImagePath
        MouseArea{
           anchors.fill: parent
        }
    }

    Text {
       id:detailcontent
       anchors.horizontalCenter: parent.horizontalCenter
       y:container.height-container.height/3*2
       text:{
           if(errorCode == -100) return "网络异常，请确认网络连接"
           if(errorCode == -200) return "服务器开小差啦，请重试..."
           if(errorCode == -300) return "系统异常"
           return "未知错误"
       }
       color: "white"
       font.pixelSize: 25
       wrapMode: Text.WordWrap
    }

    Image{
        id:line
        anchors.horizontalCenter: parent.horizontalCenter
        y: detailcontent.y+detailcontent.height+20
        width: container.bgwidth-20
        source: lineImagePath
    }

    Image {
        id: mybutton
        anchors.horizontalCenter: parent.horizontalCenter
        y:line.y+5+20
        height:40
        width:line.width/2-40
        source: (pressbutton==true)? buttonFocusOnImagePath:buttonFocusOffImagePath
        Text {
            id: buttontext
            anchors.verticalCenter: mybutton.verticalCenter
            anchors.horizontalCenter : mybutton.horizontalCenter
            font.pixelSize: 25
            text: buttonText
        }
        MouseArea{
            anchors.fill: parent;
            onPressed: {
                pressbutton=true;
            }
            onReleased: {
                pressbutton=false;
            }
            onExited: {
                pressbutton=false;
            }
            onClicked:{
                container.clickbutton();
            }
        }
    }

}
