import Qt 4.7

Rectangle {
    id:container

    property int bgwidth:parent.width
    property int bgheigh:parent.height
    property string content: "no content"
    property string buttonFocusOnImagePath: "../pics/PopupFocusOnButton.png"
    property string buttonFocusOffImagePath: "../pics/PopupFocusOffButton.png"
    property string leftButtonText: "left"
    property string rightButtonText: "right"
    property string backgroundImagePath: "../pics/PopupBG.png"
    property string lineImagePath: "../pics/PopupGreenLine.png"
    property bool pressleftbutton: true
    property bool pressrightbutton: false

    width: bgwidth
    height: bgheigh
    color: "transparent"

    signal clickleft
    signal clickright

    Image{
        id:bg
        x:0
        y:0
        width: container.bgwidth
        height: container.bgheigh
        source: backgroundImagePath
        MouseArea{
           anchors.fill: parent
        }
    }

    Text {
       id:detailcontent
       x:50
       y:container.height-container.height/3*2
       width:container.bgwidth-100
       text:content
       color: "white"
       font.pixelSize: 25
       wrapMode: Text.WordWrap
    }

    Image{
        id:line
        anchors.horizontalCenter: parent.horizontalCenter
        y: detailcontent.y+detailcontent.height+20
        width: container.bgwidth-20
        source: lineImagePath
    }

    Image {
        id: buttonleft
        x:line.x+20
        y:line.y+5+20
        height:40
        width:line.width/2-40
        source: (pressleftbutton==true)? buttonFocusOnImagePath:buttonFocusOffImagePath
        Text {
            id: leftbuttontext
            anchors.verticalCenter: buttonleft.verticalCenter
            anchors.horizontalCenter : buttonleft.horizontalCenter
            font.pixelSize: 25
            text: leftButtonText
        }
        MouseArea{
            anchors.fill: parent;
            onPressed: {
                pressleftbutton=true;
                pressrightbutton=false;
            }
            onReleased: {
                pressleftbutton=false;
                pressrightbutton=true;
            }
            onClicked:{
                container.clickleft();
            }
        }
    }

    Image {
        id: buttonright
        x:line.x+line.width/2+20
        y:line.y+5+20
        height:40
        width:line.width/2-40
        source: (pressrightbutton==true)? buttonFocusOnImagePath:buttonFocusOffImagePath
        Text {
            id: rightbuttontext
            anchors.verticalCenter: buttonright.verticalCenter
            anchors.horizontalCenter : buttonright.horizontalCenter
            font.pixelSize: 25
            text: rightButtonText
        }
        MouseArea{
            anchors.fill: parent;
            onPressed: {
                pressleftbutton=false;
                pressrightbutton=true;
            }
            onReleased: {
                pressleftbutton=true;
                pressrightbutton=false;
            }

            onClicked:{
                container.clickright();
            }
        }
    }

}
