import Qt 4.7

Rectangle {
    id:container

    property int bgwidth:parent.width
    property int bgheigh:parent.height
    property string content: "no content"
    property string closeImagePath: "../pics/CloseIcon.png"
    property string closeClickedImagePath: "../pics/CloseIconClicked.png"
    property string backgroundImagePath: "../pics/PopupBG.png"
    property string lineImagePath: "../pics/PopupGreenLine.png"
    property bool  clickedCloseFlag: false

    width: bgwidth
    height: bgheigh
    color: "transparent"

    signal clickclose

    Image{
        id:bg
        x:0
        y:0
        width: container.bgwidth
        height: container.bgheigh
        source: backgroundImagePath
        MouseArea{
           anchors.fill: parent
        }
    }

    Text {
       id:detailcontent
       x:50
       y:container.height-container.height/3*2
       text:content
       width:container.bgwidth-100
       color: "white"
       font.pixelSize: 25
       wrapMode: Text.WordWrap
    }

    Rectangle {
        id: closeimage
        x:container.width-100
        y:detailcontent.y-100
        width: 100
        height:100
        color: "transparent"
        Image{
            anchors.right: parent.right
            anchors.bottom: parent.bottom
            anchors.rightMargin: 40
            anchors.bottomMargin: 20
            source: (clickedCloseFlag==false)? closeImagePath :closeClickedImagePath
        }
        MouseArea{
            anchors.fill: parent
            onPressed: {
                clickedCloseFlag = true;
            }
            onReleased: {
                clickedCloseFlag = false;
            }

            onClicked: {
                container.clickclose();
            }
        }
    }

    Image{
        id:line
        anchors.horizontalCenter: parent.horizontalCenter
        y: detailcontent.y+detailcontent.height+20
        width: container.bgwidth-20
        source: lineImagePath
    }
}
